var dtaccountParam={
    "transacctype":"0"/*1定投子账户(该字段是在定投设置成功页面上增加的)*/
}

//textarea自适应高度
function initTxtArea(){
    var text = document.getElementById("nameinput");
    autoTextarea(text);// 调用
}

/**
 * 文本框根据输入内容自适应高度
 * @elem                {HTMLElement}输入框元素
 * @extra               {Number}设置光标与输入框保持的距离(默认0)
 * @maxHeight           {Number}设置最大高度(可选)
 */
function autoTextarea (elem, extra, maxHeight) {
    extra = extra || 0;
    var isFirefox = !!document.getBoxObjectFor || 'mozInnerScreenX' in window,
        isOpera = !!window.opera && !!window.opera.toString().indexOf('Opera'),
        addEvent = function (type, callback) {
            elem.addEventListener ?
                elem.addEventListener(type, callback, false) :
                elem.attachEvent('on' + type, callback);
        },
        getStyle = elem.currentStyle ? function (name) {
            var val = elem.currentStyle[name];

            if (name === 'height' && val.search(/px/i) !== 1) {
                var rect = elem.getBoundingClientRect();
                return rect.bottom - rect.top -
                    parseFloat(getStyle('paddingTop')) -
                    parseFloat(getStyle('paddingBottom')) + 'px';
            }

            return val;
        } : function (name) {
            return getComputedStyle(elem, null)[name];
        },
        minHeight = parseFloat(getStyle('height'));

    elem.style.resize = 'none';

    var change = function () {
        var scrollTop, height,
            padding = 0,
            style = elem.style;

        if (elem._length === elem.value.length) return;
        elem._length = elem.value.length;

        if (!isFirefox && !isOpera) {
            padding = parseInt(getStyle('paddingTop')) + parseInt(getStyle('paddingBottom'));
        }
        scrollTop = document.body.scrollTop || document.documentElement.scrollTop;

        elem.style.height = minHeight + 'px';
        if (elem.scrollHeight > minHeight) {
            if (maxHeight && elem.scrollHeight > maxHeight) {
                height = maxHeight - padding;
                style.overflowY = 'auto';
            } else {
                height = elem.scrollHeight - padding;
                style.overflowY = 'hidden';
            }
            style.height = height + extra + 'px';
            scrollTop += parseInt(style.height) - elem.currHeight;
            /* document.body.scrollTop = scrollTop;
             document.documentElement.scrollTop = scrollTop;*/
            elem.currHeight = parseInt(style.height);
        }
    };

    addEvent('propertychange', change);
    addEvent('input', change);
    addEvent('focus', change);
    change();
}


//是否包含某些特殊字符串
function filterStr(str){
    var myReg = /[`~!@#$%^&*+=|{}:;\[\]<>/?~！@#￥%……&*（）——+|【】‘；：”“’。？_]/;
    return (myReg.test(str));
}
/*修改的定投计划名称提交*/
function editnamesubmit(defaultdtname){
    var edditandsubmit = $('#edditandsubmit');
    if(edditandsubmit.hasClass('forbid')){
        return;
    }
    var nameinput = $('#nameinput');
    var nametips = $('#nametips');
    var nameinput_val = $.trim(nameinput.val());
    var tipsstr='';
    var param={};
    var scheduleid = Com.getQueryStringByName('sid');
    var ofcode = Com.getQueryStringByName('ofn');
    if(typeof defaultdtname!='undefined' && defaultdtname==nameinput_val){
        nametips.html('').css('display','none');
        /*修改成功后，将输入框禁止输入，并且显示换一换(如有)和编辑按钮*/
        $('.nameeditbox').removeClass('editboxmain');
        $('#nameinput').attr('disabled','disabled');
        $('#edditandsubmit').attr('dataaction','1');
        initTxtArea();
        return;
    }
    if(nameinput_val==''){
        tipsstr='请输入定投计划名称';
        nametips.html(tipsstr).css('display','block');
        return;
    }
    if(filterStr(nameinput_val)){
        tipsstr='名称不能含有特殊字符';
        nametips.html(tipsstr).css('display','block');
        return;
    }
    if(nameinput_val.length>18){
        tipsstr='最多可输入18个字，请调整';
        nametips.html(tipsstr).css('display','block');
        return;
    }
    nametips.html('').css('display','none');
    edditandsubmit.addClass('forbid');
    param['planname'] = nameinput_val;
    param['scheduleid'] = scheduleid;
    param['ofcode'] = ofcode;

    var ajaxData = function(datajson){
        Com.ajax({
            "url":Com.getOrigin()+'/gsfinancing/ofschedule/setSmartPlanname/1.0',
            "data":datajson,
            "type":"post",
            "dataType":"json",
            "success":function(d){
                edditandsubmit.removeClass('forbid');
                Com.ajaxLoaded();
                if(d.result[0].code == '0'){
                    nametips.html('').css('display','none');
                    /*修改成功后，将输入框禁止输入，并且显示换一换(如有)和编辑按钮*/
                    $('.nameeditbox').removeClass('editboxmain');
                    $('#nameinput').attr('disabled','disabled');
                    $('#edditandsubmit').attr('dataaction','1');
                    initTxtArea();
                }
                else if(d.result[0].code == '11' || d.result[0].code == '18' || d.result[0].code == '19'){
                    return false;
                }
                else if(d.result[0].code == '6101999'){
                    nametips.html('和已有名称冲突，请调整').css('display','block');
                }
                else{
                    /*6101901【定投计划编号】参数不合法||6101902未指定【定投计划名称】||6101999定投计划名称已存在*/
                    nametips.html(d.result[0].msg).css('display','block');
                }
            },
            "isTradeLogin":true,
            "error":function(){
                edditandsubmit.removeClass('forbid');
                Com.ajaxLoaded();
                Com.showNativeAlert('','网络不给力|setSmartPlanname',['确定'],'')
            }
        });
    };
    ajaxData(param);

}


/*换一换随机取一个名称*/
function getRadomPlanName(){
    var changename = $('#changename');
    if(changename.hasClass('forbid')){
        return;
    }
    changename.addClass('forbid');
    var nameinput = $('#nameinput');
    var param={};
    var scheduleid = Com.getQueryStringByName('sid');
    var ofcode = Com.getQueryStringByName('ofcode');
    param['scheduleid'] = scheduleid;
    param['ofcode'] = ofcode;

    var ajaxData = function(datajson){
        Com.ajax({
            "url":Com.getOrigin()+'/gsfinancing/ofschedule/getDefaultSmartPlanname/1.0',
            "data":datajson,
            "type":"post",
            "dataType":"json",
            "success":function(d){
                changename.removeClass('forbid');
                Com.ajaxLoaded();
                if(d.result[0].code == '0'){
                    if(d.data.length>0){
                        if(typeof d.data[0].plannametype!='undefined' && d.data[0].plannametype==1){
                            //名称用完了
                            Com.nativeToast('系统可选名称已用完，无法换一换。','0');
                            $('#changename').remove();
                        }else{
                            if(typeof d.data[0].planname!='undefined' && d.data[0].planname!=''){
                                $('#nameinput').removeAttr('disabled').html(d.data[0].planname).attr('disabled','disabled');
                            }
                        }
                    }
                }
                else if(d.result[0].code == '11' || d.result[0].code == '18' || d.result[0].code == '19'){
                    return false;
                }
                else{
                    Com.showNativeAlert("",d.result[0].msg,["确定"],'');
                }
            },
            "isTradeLogin":true,
            "error":function(){
                changename.removeClass('forbid');
                Com.ajaxLoaded();
                Com.showNativeAlert('','网络不给力|getDefaultSmartPlanname',['确定'],'')
            }
        });
    };
    ajaxData(param);

}

/*定投结果页面上查询是否是定投子账户*/
function chkDtacct(){
    var dt = Com.getQueryStringByName('dt');
    if(dt!=2){
        //新增定投，看下是否开启了子账户
        dtaccountParam.transacctype= Com.getLocalValue('itc_openzzh');//是否开启子账户  1开启
    }else{
        //修改定投，看下定投详情返回的是否是子账户
        dtaccountParam.transacctype = Com.getLocalValue('itc_transacctype');/*0：主账户；1：子账户*/
    }

    if(dtaccountParam.transacctype!=1){
        /**
         * 1、不是子账户 闹钟没有持仓收益率,为了简化程序复杂度，在这里把开关关掉
         * 2、不是子账户，默认开启累计申购金额闹钟开关
         * */
        times_set_flag = false;
        amt_set_flag = true;
        $('#times_check').prop('checked',false);
        $('#amt_check').prop('checked',true);

        /*隐藏收益率闹钟设置项*/
        $('#ishowccsyl').css('display','none');
    }
}

/*定投详情页面上查询是否是定投子账户*/
function chkDtDetailsacct(transacctype){
    dtaccountParam.transacctype = transacctype;

    if(dtaccountParam.transacctype!=1){
        /**
         * 1、不是子账户 闹钟没有持仓收益率,为了简化程序复杂度，在这里把开关关掉
         * 2、不是子账户，默认开启累计申购金额闹钟开关
         * */
        times_set_flag = false;
        amt_set_flag = true;
        $('#times_check').prop('checked',false);
        $('#amt_check').prop('checked',true);

        /*隐藏收益率闹钟设置项*/
        $('#ishowccsyl').css('display','none');
    }
}


function splitStr (){
    var clientType =Com.clientType();
    var splitStr='<br/>';
    if(clientType=='ios'){
        splitStr='\n';
    }
    return splitStr;
}