var rankDataObj={
    topmenuactive:'jzgs',
    rankdata:[''],
    pagenum:0,
    pagesize:20,
    oftype:'',/*当前查哪种类型的基金涨幅排行*/
    isindex:'',/*是否是指数型*/
    sorttype:'0',/*0降序 1升序*/
    sortflag:'0',/*0涨跌幅 1净值*/
    isshowTopMenu:'',/*是否需要显示顶部的三个菜单*/
    dataEmpty:false,
    timeOutGetHeight:null,
    isScrollLoading:true,//当前是否可以加载数据
    clonefixedbar_top:0,
    isanumation:false,/*是否需要加载转圈动画*/
    iscfh:'',/*如果是从财富号跳转到来的，地址会有这个参数*/
    cfhSearch:'',/*如果是从财富号跳转到来的，跳转到详情的时候需要固定在详情地址加参数'&channel=cfh&protype=3&brokercode=CFH_'+companyid*/
    companyId:"",/*如果只查某个基金公司的该字段从页面地址上取*/
    splitStr:'\n',//全屏弹框说明文字间的分隔符
    shownodatabox:false,/*是否显示暂无数据的图片*/
    turntimer:null,
    defaultTimeStr:(new Date()).getTime()/*间隔3秒点击一次刷新才有效*/


};
var appvue = new Vue({
    el:'#app',
    data:rankDataObj,
    created : function(){
        var self = this;
    },
    methods:{
        /*切换顶部菜单*/
        topmenuClick:function(menustr){
            if(rankDataObj.topmenuactive==menustr){
                return;
            }
            Com.ajaxLoading();
            rankDataObj.topmenuactive=menustr;
            if(menustr=='yjph'){
                window.location.href=Com.getOrigin()+'/asset/mfund/pages/fund_fr_list.html?ishowmenu=1'+rankDataObj.cfhSearch;
            }
            else if(menustr=='dtph'){
                window.location.href=Com.getOrigin()+'/asset/mfund/pages/fund_fr_dt_list.html?ishowmenu=1'+rankDataObj.cfhSearch;
            }
        },
        choosetype:function(typestr){
            if(typestr==-1){
                rankDataObj.oftype='';
                rankDataObj.isindex='1';
            }else{
                rankDataObj.oftype=typestr;
                rankDataObj.isindex='0';
            }
            exports.setDefaultParam();
            exports.getGZInfoData();
        },
        /*点击刷新按钮*/
        loadrefesh:function(){
            var date = new Date();
            var timestr = date.getTime();
            if(timestr - rankDataObj.defaultTimeStr<3000){
                Com.nativeToast('净值估值计算频率约为1分钟，无需频繁刷新');
                return;
            }
            /*if(rankDataObj.turntimer){
                return;
            }*/

            rankDataObj.isanumation = true;
            rankDataObj.defaultTimeStr = timestr;
            /*rankDataObj.rankdata=[];
            rankDataObj.pagenum=0;
            rankDataObj.sorttype=0;*/
            exports.setDefaultParam();
            exports.getGZInfoData(false,'1');
            rankDataObj.turntimer = setTimeout(function(){
                rankDataObj.isanumation = false;
                clearTimeout(rankDataObj.turntimer);
                rankDataObj.turntimer = null;
            },400)
        },
        /*切换涨跌幅的升降序排序*/
        sorttypeHandle:function(){
            rankDataObj.rankdata=[];
            rankDataObj.pagenum=0;
            rankDataObj.sorttype=(rankDataObj.sorttype==0?1:0);
            rankDataObj.sortflag='0';
            exports.getGZInfoData();
        },
        /*点击净值排序*/
        sortjzHandle:function(){
            rankDataObj.rankdata=[];
            rankDataObj.pagenum=0;
            rankDataObj.sorttype=(rankDataObj.sorttype==0?1:0);
            rankDataObj.sortflag='1';
            exports.getGZInfoData();
        },
        /*估值计算提示说明*/
        gzjstips:function(){
            Com.showScreenMask('基金净值估算','净值估算算法：选取全市场宽基、风格、行业等500多个指数，计算指数与基金走势的相关性 、筛选出相关性高的指数，并用回归算法估算基金中每个指数的权重占比；盘中根据指数的涨跌幅来预估基金净值的涨跌幅。'+rankDataObj.splitStr+rankDataObj.splitStr+'风险提示：净值估算数据可能与最终净值存在差异，数据仅供参考，不代表实际业绩；请以基金公司公布数据为准。');
        },
        /*跳转到详情*/
        godetails:function(obj){
            if(obj.ofcode!=''){
                Com.newWebViewOpenPage('',{'pageUrl':Com.getOrigin()+'/asset/mfund/pages/fund_details.html?ofcode='+obj.ofcode+rankDataObj.cfhSearch,"weburl":Com.getOrigin()+'/asset/mfund/pages/fund_details.html?ofcode='+obj.ofcode+rankDataObj.cfhSearch});
            }else{
                Com.showNativeAlert('','基金代码为空',['确定'],'');
            }

            try
            {
                TalkingData.onEventWithLabel("基金净值估算",'基金排行页-净值估算Tab-基金点击');
            } catch(err) {}
        }

    },
    filters:{

    }
});
var exports = {
    init:function(){
        $('#defautltempmenu').css('display','none');
        Com.ajaxLoaded();
        exports.getGZInfoData();
        exports.splitStr();
        $(window).on('scroll',function(){
            var clonefixedbar = $('#gz_top_fixed');
            var oheight = $(document).height();
            var wheight = $(window).height();
            var wintop = $(window).scrollTop();
            if((wintop+wheight >= oheight-2) && wintop>0 && oheight>wheight){
                //Com.nativeToast('数据加载中')
                if(!rankDataObj.isScrollLoading || rankDataObj.rankdata.length==0){
                    return false;
                }
                rankDataObj.pagenum = parseInt(rankDataObj.pagenum)+1;
                exports.getGZInfoData();
            }
        });
    },

    urlparamInit:function(){
        var oftype = Com.getQueryStringByName('oftype');
        var isindex = Com.getQueryStringByName('isindex');
        var ishowmenu = Com.getQueryStringByName('ishowmenu');
        var iscfh = Com.getQueryStringByName('cfh');
        var companyid = Com.getQueryStringByName('companyid');
        if(isindex==1){
            rankDataObj.isindex = 1;
        }
        if(typeof oftype!='undefined' && oftype!=''){
            rankDataObj.oftype = oftype;
        }
        if(typeof ishowmenu!='undefined' && ishowmenu!=''){
            rankDataObj.ishowmenu = ishowmenu;
        }
        if(typeof iscfh!='undefined' && iscfh!=''){
            rankDataObj.iscfh = iscfh;
        }
        if(typeof companyid!='undefined' && companyid!=''){
            rankDataObj.companyId = companyid;
        }
        if(iscfh == '1'){
            //财富号跳转过来的地址要加参数，到详情页面上会给虚拟推荐人绑定关系
            rankDataObj.cfhSearch = '&channel=cfh&protype=3&brokercode=CFH_'+companyid;
        }
    },
    setDefaultParam:function(){
        rankDataObj.rankdata=[];
        rankDataObj.pagenum=0;
        rankDataObj.sorttype=0;
        rankDataObj.sortflag=0;
    },
    /*获取估值排行榜*/
    getGZInfoData: function (caculateOffsetTop,refreshpic){
        rankDataObj.shownodatabox = false;
        //rankDataObj.isanumation = true;
        rankDataObj.isScrollLoading = false;
        var param = {};
        param['oftype'] = rankDataObj.oftype;
        param['isindex'] = rankDataObj.isindex;
        param['pagenum'] = rankDataObj.pagenum;
        param['pagesize'] = rankDataObj.pagesize;
        param['sorttype'] = rankDataObj.sorttype;
        param['sortflag'] = rankDataObj.sortflag;
        Com.ajaxLoading();
        Com.ajax({
            "url":Com.getOrigin()+"/gsfinancing/fundinfo/getrtranklist/1.0",
            "data":param,
            "type":"post",
            "dataType":"json",
            "success":function(d){
                Com.ajaxLoaded();
                rankDataObj.isScrollLoading = true;
                //rankDataObj.isanumation = false;
                if(d.result[0].code == '0'){

                    if(d.data.length>0){
                        if(rankDataObj.pagenum==0){
                            //第一次下拉加载
                            rankDataObj.rankdata = d.data;
                        }else{
                            for(var i = 0;i<d.data.length;i++){
                                rankDataObj.rankdata.push(d.data[i]);
                            }
                        }

                        if(d.data.length<Number(rankDataObj.pagesize)){
                            //如果当前获取到的数据小于分页条数，禁止滑动加载
                            rankDataObj.isScrollLoading = false;
                        }
                        if(typeof refreshpic!='undefined' && refreshpic=='1'){
                            Com.nativeToast('已更新基金估值数据');
                        }

                    }else{
                        //如果当前获取到的数据是空，禁止滑动加载
                        rankDataObj.isScrollLoading = false;

                        /*data为空且pagenum是0说明第一次加载就是空，显示暂无数据图片*/
                        rankDataObj.shownodatabox = (rankDataObj.pagenum==0);

                    }
                    if(rankDataObj.pagenum>0){
                        if((d.data.length>0&&d.data.length<Number(rankDataObj.pagesize))||(d.data.length==0&&rankDataObj.pagenum>0)){
                            //如果当前获取到的数据小于分页条数，禁止滑动加载
                            rankDataObj.isScrollLoading = false;
                            Com.nativeToast('没有更多数据');
                        }
                    }

                    if(rankDataObj.clonefixedbar_top==0 ||caculateOffsetTop){
                        exports.getActiveHeight();
                    }
                }else if(d.result[0].code == '11' || d.result[0].code == '18' || d.result[0].code == '19'){
                    if(typeof refreshpic!='undefined' && refreshpic=='1'){
                        Com.nativeToast('数据获取失败，请稍后重试');
                    }
                    return false;
                }else{
                    if(typeof refreshpic!='undefined' && refreshpic=='1'){
                        Com.nativeToast('数据获取失败，请稍后重试');
                    }
                }
            },
            "isTradeLogin":false,
            "error":function(){
                Com.ajaxLoaded();
                if(typeof refreshpic!='undefined' && refreshpic=='1'){
                    Com.nativeToast('网络不给力|数据获取失败，请稍后重试');
                }
                rankDataObj.isScrollLoading = true;
                //Com.showNativeAlert('','网络不给力|getrtranklist',['确定'],'')
            }
        });
    },
    getActiveHeight:function(){
        //延迟50ms获取一下高度
        if(rankDataObj.timeOutGetHeight) clearTimeout(rankDataObj.timeOutGetHeight);
        rankDataObj.timeOutGetHeight = setTimeout(function(){
            var clonefixedbar = $('#gz_top_fixed');
            rankDataObj.clonefixedbar_top = (Math.round(Number(clonefixedbar.height()))).toFixed(2);//切换顶部菜单时由于解释文字长度不一致会导致class=='irnkbg'的高度不一致，因此，切换顶部菜单时需要更新一下这个值，调试的时候要处理
        },10)
    },
    splitStr : function(){
        var clientType =Com.clientType();
        var splitStr='<br/>';
        if(clientType=='ios'){
            splitStr='\n';
        }
        rankDataObj.splitStr = splitStr;
    },




};

exports.init();