/**
 * Created by guosen on 2018/12/17.
 */

import et from  '__ROOTPATH__/H5_common/asset/common_tool/event.js';
import $ from  '__ROOTPATH__/H5_common/asset/common_tool/zepto.js';
import Com from '__ROOTPATH__/H5_common/asset/common_tool/app_common_bridge.js';
import Vue from 'vue';
import tool_fun from '__ROOTPATH__/H5_common/asset/common_tool/common_fun.js';
import Dialog from '__ROOTPATH__/H5_common/asset/common_tool/components/dialog/';//替换新弹窗组件原组件有兼容性

require('__ROOTPATH__/H5_common/asset/common_tool/common.css');
require('../css/common.scss');
require('../css/apply_content.scss');
const applySureTpl = require('../tpl/apply_detail.html');


const dataObj = {
	info: {},
	type: tool_fun.getParam('type'),
	mapStatus: {
		0: '成功',
		2: '失败'
	},

};
const configData = {
	mapStatus: {
		I: '公开发行询价',
		F: '公开发行申购',
		i: '公开发行询价',
		f: '公开发行申购',
		7: '可转债或可交换债发行',
		a: '新股发行'
	},
	param: tool_fun.getParam('param')
};
et.eventBind();
const exports = {
	init: function () {
		if(configData.param) {
			configData.param = JSON.parse(decodeURIComponent(Com.base64Decode(configData.param)));
		} else {
			configData.param = {};
		}
		dataObj.info = configData.param;
		//JSON.parse(Base64.decode(decodeURI(data)));
		new Vue({
			el: '#domDiv',
			data: dataObj,
			methods:{
				retStatus: function (ret) {
					return configData.mapStatus[ret] ? configData.mapStatus[ret] : '其它发行类型';
				}
			},
			template: '<div class="apply-pre">' + applySureTpl + '</div>'
		});
		Com.setWebviewTitle('', {'title': '详情'});
	}

}

exports.init();
