/*杂七杂八的一些字段方进来*/
var dataObj={
    splitStr:'\n',//全屏弹框说明文字间的分隔符
    hasvideo:false,
    haspiccontent:false,
    jjjdvideo:{},/*基金解读视频信息*/
    sysVer:'',
    isremindBtnSatus:true,/*开售提醒按钮的可点击状态*/
    isreminded:false,/*开售提醒设置成功后改成true*/
    isCallNativeRegPage:false,/*点击开售提醒，是否调起了客户端的注册登录界面,true调起了手机号登录界面*/
    choosetime:'1m',
    chooseindex:'',/*初始情况下，也就是用户没有主动选择指数的情况下，该值为空，只要客户选择过，就替换该值*/
    indexname:'沪深300'
};
//产品风险等级字典
var ofRiskValues= {
  "0":"未测评",
  "1":"R1(低风险)",
  "2":"R2(中低风险)",
  "3":"R3(中风险)",
  "4":"R4(中高风险)",
  "5":"R5(高风险)"
}

//日期拆分YYYYMMDD------>MM--DD
template.helper('datehg2', function (str) {
    if(str.length==8){
        return dateYear = (str.substring(4,6))+'-'+(str.substring(6,8));
    }
    else if(str.length==4){
        return dateYear = (str.substring(0,2))+'-'+(str.substring(2,4));
    }else{
        return str;
    }
});
//万分收益数据格式化
template.helper('millionFormat', function (num) {
    return num = ((num*1).toFixed(4)).toString();
});
//收益率数据格式化
template.helper('rateFormat', function (num) {
    return num = ((num*100).toFixed(2)).toString()+'%';
});

//toFixed
template.helper('toFixed', function (num,l) {
    return num = (Number(num).toFixed(l)).toString()+'%';
});

//基金持仓各项占比数据格式化
template.helper('percentFormat', function (num) {
    return num = ((num*1).toFixed(2)).toString()+'%';
});

//净资产格式化
template.helper('asessFormat', function (num) {
    return num = ((num/100000000).toFixed(2));
});

//股票占比、持股数格式转换
template.helper('stocksFormat', function (num) {
    return num = ((num/10000).toFixed(2));
});

//带百分号数据正负判断
template.helper('pnpercent', function (num) {
    var numformat = Number(num.split('%')[0]);
    return (numformat>=0);
});


//基金详情页面头部货币型基金的7日年化*100
template.helper('newDerate', function (num,l) {
    return num = ((Number(num)*100).toFixed(l)).toString()+'%';
});



//基金详情页面头部货币型基金的7日年化*100(除去百分号)
template.helper('newDerate_new', function (num,l) {
    return num = ((Number(num)*100).toFixed(l)).toString();
});

//toFixed(去百分号)
template.helper('toFixed_new', function (num,l) {
    return num = (Number(num).toFixed(l)).toString();
});

//基金类型
template.helper('investlimitStr', function (num) {
    var str = '';
    if(num == '1'){
        str = '0-1年';
    }
    else if(num == '2'){
        str = '1-3年';
    }
    else if(num == '3'){
        str = '3-5年';
    }
    else if(num == '4'){
        str = '5年以上';
    }else{
        str = '未知';
    }
    return str;
});

template.helper('ofriskvaluename',function(v){
  return ofRiskValues[v];
})

//基金类型
template.helper('fundType', function (num) {
    return oftypechn(num);
});
function oftypechn(num){
    var typeStr = '';
    if(num == '1'){
        typeStr = '股票型';
    }
    else if(num == '2'){
        typeStr = '混合型';
    }
    else if(num == '3'){
        typeStr = '债券型';
    }
    else if(num == '4'){
        typeStr = '货币型';
    }
    else if(num == '6'){
        typeStr = 'QDII型';
    }else if(num=="7"){
        typeStr = '其他';
    }else if(num=="8"){
        typeStr = '指数型';
    }
    else{
        typeStr = "未知";
    }
    return typeStr;
}

//开放状态
template.helper('fundStatus', function (num) {
    var statusStr = '';
    if(num == '0'){
        statusStr = '正常开放';
    }
    else if(num == '1'){
        statusStr = '认购时期';
    }
    else if(num == '2'){
        statusStr = '发行成功';
    }
    else if(num == '3'){
        statusStr = '发行失败';
    }
    else if(num == '4'){
        statusStr = '停止交易';
    }
    else if(num == '5'){
        statusStr = '停止申购';
    }
    else if(num == '6'){
        statusStr = '停止赎回';
    }
    else if(num == '7'){
        statusStr = '权益登记';
    }
    else if(num == '8'){
        statusStr = '红利发放';
    }
    else if(num == '9'){
        statusStr = '基金封闭';
    }
    else if(num == 'a'){
        statusStr = '基金终止';
    }
    else{
        statusStr = '其他';
    }
    return statusStr;
});


//基金详情合并之后先去拿基金公司代码、基金类型
function getFundInfo(){

}

//查询基金详情出错，关闭当前基金详情的webview
function goHistoryPage(){
    Com.nativeGoback();
}

//全局获取基金详情便于TD统计
function getGlobalFundData(){
    var isIndex,oftypestr;
    var td_funddata={'oftype':'','ofcode':'','ofstatus':'','oftypechn':''};
    if(typeof fundInfo!='undefined' && typeof fundInfo.data!='undefined' && fundInfo.data.length!=0){
        oftypestr=fundInfo.data[0].oftype;
        isIndex=fundInfo.data[0].isindex;
        if(isIndex=='1'){
            //指数型
            oftypestr='8'
        }
        td_funddata.oftype=oftypestr;
        td_funddata.oftypechn=oftypechn(oftypestr);
        td_funddata.ofcode=fundInfo.data[0].ofcode;
        td_funddata.ofstatus=fundInfo.data[0].ofstatus;

    }
    return td_funddata;

}

/*获取基金详情*/
var fundInfo;//全局存储基金详情查到的结果集
function getFundDetails(){
    var ofn = Com.getQueryStringByName('ofcode');
    var fundDataAjax = function(fundCode){
        var param = {};
        if(!fundCode){
            Com.showNativeAlert("","缺少基金代码!",["确定"],'');
            return false;
        }
        param['ofcode'] = fundCode;
        param['flag'] = '1';//非必须入参，入参表示要查基金公司简称、是否是短期理财型基金
        param['estflag'] = '1';//1:查询是否支持实时估值 2：查询当前最新估值

        Com.ajaxLoading();
        Com.ajax({
            "url":Com.getOrigin()+"/gsfinancing/fundinfo/getfunddetail/1.0",
            "data":param,
            "type":"post",
            "dataType":"json",
            "success":function(d){
                /*590版本获取一下当前是不是周一至周五并且是09:30至15:00之间，显示盘中实时估值时用*/
                if(d.data && d.data.length>0){
                    var istradetime = getLocalTradetime();
                    d.data[0].isTradeTime = istradetime;
                    if(istradetime){
                        try
                        {
                            TalkingData.onEventWithLabel("基金净值估算",'基金详情页-净值估算Tab');
                        } catch(err) {}
                    }
                }
                //全局存储基金详情
                fundInfo = d;
                Com.ajaxLoaded();
                if(d.result[0].code == '0'){
                    if(typeof d.data !== 'undefined' && d.data.length != 0){

                        if(d.data[0].oftype=='3'){
                            dataObj.chooseindex='profit_zzqz';
                            dataObj.indexname = '中证全债';
                        }else{

                            if(d.data[0].isindex=='1'){
                                if(d.data[0].indexcode=='000300'){
                                    dataObj.indexname = '沪深300';
                                    dataObj.chooseindex='profit_hs300';
                                }
                                else if(d.data[0].indexcode=='000001'){
                                    dataObj.indexname = '上证指数';
                                    dataObj.chooseindex='profit_szzs';
                                }
                                else if(d.data[0].indexcode=='399001'){
                                    dataObj.indexname = '深证成指';
                                    dataObj.chooseindex='profit_szcz';
                                }
                                else if(d.data[0].indexcode=='399006'){
                                    dataObj.indexname = '创业板指';
                                    dataObj.chooseindex='profit_cybz';
                                }
                                else if(d.data[0].indexcode=='399005'){
                                    dataObj.indexname = '中小板指';
                                    dataObj.chooseindex='profit_zxbz';
                                }
                                else if(d.data[0].indexcode=='000905'){
                                    dataObj.indexname = '中证500';
                                    dataObj.chooseindex='profit_zz500';
                                }else{
                                    dataObj.indexname = '沪深300';
                                    dataObj.chooseindex='profit_hs300';
                                }
                            }else{
                                //其余都显示沪深300
                                dataObj.indexname = '沪深300';
                                dataObj.chooseindex='profit_hs300';
                            }
                        }

                        //设置标题
                        Com.setWebviewStockTitle('',{"stockName":d.data[0].secuabbr,"stockCode":d.data[0].ofcode,"bgColor":"589DFC"},true);

                        var typechn= d.data[0].oftype;
                        var isindex = d.data[0].isindex;

                        fundInfo.data[0].orioftype = d.data[0].oftype;
                        d.data[0].orioftype = d.data[0].oftype;
                        if(isindex==1){
                            typechn='8';//指数型基金
                        }
                        var tdoftype=oftypechn(typechn);

                       /* queryTradeStatusNoLogin('J',d.data[0].ofcode,'0','1',function(pm){
                            if(typeof pm.preflag!='undefined' && pm.preflag=='0'){
                                //非交易时间
                                try
                                {
                                    TalkingData.onEventWithLabel('非交易时间-理财交易断点分析-开放式基金','1-产品详情-'+d.data[0].ofcode+'-'+d.data[0].ofname);
                                } catch(err) {}
                            }

                        });*/
                        try
                        {
                            TalkingData.onEventWithLabel('理财购买断点分析-开放式基金','1产品详情-'+ofn+'-'+d.data[0].secuabbr);
                        } catch(err) {}


                        try
                        {

                            TalkingData.onEventWithLabel("开放式基金详情页",'基金详情页-'+tdoftype);
                        } catch(err) {}

                        win_tan = d.data[0].tacode;
                        win_oftype = d.data[0].oftype;
                        win_ofn = d.data[0].ofcode;
                        Com.setLocalValue('secuid',d.data[0].secuid);
                        Com.setLocalValue('ofstatus',d.data[0].ofstatus);


                        //视频介绍入口
                        d.liveflag = fundInfo.data[0].liveflag;
                        d['liveid'] = Com.getQueryStringByName('liveid');
                        d['livetype'] = Com.getQueryStringByName('livetype');
                        d['livename'] = Com.getQueryStringByName('livename');

                        var from = Com.getQueryStringByName('from');
                        //调用客户端的方法，判断当前基金是不是自选基金，将该数据填充到result中，页面上好判断
                        d.data[0].iszx = mfundCom.isOptionalFund(d.data[0].ofcode,'J');
                        d.data[0].from = from;

                        /*590新增参数:notifystatus先初始默认设置成-1，表示未查询到开售提醒订阅状态前，按钮不显示文字*/
                        d.data[0].notifystatus = '-1';

                        var oHtml1 = $(template('topData', d.data[0]));//头部数据
                        var oHtml2 = $(template('maincontent', d));//主题框架内容
                        var oHtml3 = $(template('buttonbox', d.data[0]));//底部按钮
                        $('#details_top').html(oHtml1);
                        $('#fundcontent').html(oHtml2);
                        $('#bottombtn').html(oHtml3);

                        if(typeof d.data[0].ofcode!='undefined' && d.data[0].ofcode!=''){
                            if(d.data[0].ofstatus=='q'){
                                getIsReminded(d.data[0].ofcode,d.data[0].tacode,function(dyflag){
                                    d.data[0].notifystatus = dyflag;
                                    dataObj.isreminded = dyflag;
                                    getCfhNewInfo(d.data[0].ofcode,d.data[0]);
                                });
                            }else{
                                //查询是否有财富号最新动态
                                getCfhNewInfo(d.data[0].ofcode,d.data[0]);
                            }

                        }

                        //是否需要展示基金解读（有正在活动中的运营基金就展示）/*587版本去掉了*/
                        //isShowFundactivity(d.data[0].ofcode);

                        //获取基金交易信息
                        getTradeInfo(d.data[0].ofcode,function(sd){
                            if(typeof sd!='undefined' && sd.data && sd.data.length>0){
                                sd.detailsdata = d.data;
                                var tradeHtml = $(template('tradeInfo', sd));//底部按钮
                                $('#tradeInfoBox').html(tradeHtml);
                            }
                        });

                        var personalids='';
                        if(typeof d.data !='undefined' &&d.data.length!=0){
                            if(d.data[0].ofstatus=='1'||d.data[0].ofstatus=='q'){
                                try
                                {

                                    TalkingData.onEventWithLabel("开放式基金详情页",'新发基金页-'+tdoftype+'-'+ d.data[0].ofcode+'-基金经理Tab');
                                } catch(err) {}

                                try
                                {

                                    TalkingData.onEventWithLabel("开放式基金详情页",'新发基金页-'+tdoftype);
                                } catch(err) {}

                                /*新基金*/
                                if(typeof d.data2 !='undefined' &&d.data2.length!=0){
                                    //循环一下基金详情拿到的data2结果集，data2.length代表有几个基金经理
                                    for(var i =0;i<d.data2.length;i++){
                                        if(personalids==''){
                                            personalids+=d.data2[i].personalid;
                                        }else{
                                            personalids+=','+d.data2[i].personalid;
                                        }
                                    }

                                    //入参基金经理id去拿基金经理信息
                                    getManageInfo(personalids);

                                    //入参基金公司id去拿基金公司规模排名和画柱状图
                                    getfundCompanyInfo(d.data[0].investadvisorcode);
                                }
                                /*如果是新基金查询一下基金解读信息*/
                                getjjjdinfo(d.data[0].ofcode);
                            }else{

                                try
                                {

                                    TalkingData.onEventWithLabel("开放式基金详情页",'老基金页-'+tdoftype);
                                } catch(err) {}

                                if(d.data[0].oftype==4){
                                    //老基金货币基金拿图表数据
                                    getChartsData();
                                    /*0427增加埋点*/
                                    if(d.data[0].financeflag=='1'){
                                        try
                                        {
                                            TalkingData.onEventWithLabel("理财-使用分析",'理财产品详情页-基金-理财型');
                                        } catch(err) {}
                                    }else{
                                        try
                                        {
                                            TalkingData.onEventWithLabel("理财-使用分析",'理财产品详情页-基金-货币型');
                                        } catch(err) {}
                                    }

                                }else{

                                    if(typeof d.data[0].estallow!='undefined'&&d.data[0].estallow=='1'){
                                        /*支持实时估值，查实时估值图表数据画图*/
                                        getPriceOnTime(d.data[0].ofcode);

                                        /*获取当前是不是交易时间段*/
                                        /*getTradeTime(function(tdsd){
                                            if(tdsd.isTradeTime){
                                                //是交易时间
                                                $('.oldchartsmenu').removeClass('on').eq(1).addClass('on');
                                                $('.oldcharts').removeClass('overnone').eq(0).addClass('overnone');
                                                try
                                                {
                                                    TalkingData.onEventWithLabel("基金净值估算",'基金详情页-净值估算Tab');
                                                } catch(err) {}
                                            }
                                        })*/
                                    }


                                    //老基金-非货币基金取业绩走势,默认近一月数据
                                    yjChartsAjax('1m');
                                    /*0427增加埋点*/
                                    if(d.data[0].financeflag=='1'){
                                        try
                                        {
                                            TalkingData.onEventWithLabel("理财-使用分析",'理财产品详情页-基金-理财型');
                                        } catch(err) {}
                                    }else{
                                        try
                                        {
                                            TalkingData.onEventWithLabel("理财-使用分析",'理财产品详情页-基金-其他类型');
                                        } catch(err) {}
                                    }
                                }

                                if(d.data[0].oftype == '6'){
                                    //老基金QDII类型获取重仓股
                                    getQDIIHold(d.data[0].secuid);
                                }else{
                                    //老基金非QDII类型获取重仓股
                                    highHoldList(d.data[0].secuid);
                                }


                                if(d.data[0].oftype == 4){
                                    //老基金-货币基金-规模柱状图
                                    fundguimo(d.data[0].secuid,'hbtype');

                                    //老基金-货币基金-基金公司名称、排名、规模、基金经理姓名
                                    hbfundInfo(d.data[0].investadvisorcode);
                                }else{

                                    //查基金规模
                                    fundguimo(d.data[0].secuid,'normaltype');

                                    //查业绩走势(页面初始加载取1m:近一月的数据)
                                    //queryYjCharts(d.data[0].secuid,'1m');

                                    //指数型基金
                                    if(d.data[0].showindexflag == 1){
                                        //指数型基金取指数详情及跟踪标的
                                        getIndexFundDetail(d.data[0].indexid);
                                    }else{
                                        //展示基金经理信息

                                        F.fundScan.baseInfo(d.data[0].ofcode);
                                    }

                                }
                            }
                        }

                        //是否为自选基金
                        Com.isZxFund(ofn,isZxJsCallback);
                        //是否显示经典老基
                        if(Number(d.data[0].isoldfundflag) == '1'){
                            $('#classic_fund').show();
                        }
                        //接入客服模块
                        var ywhj = '';
                        if(d.data[0].oftype=='4'){
                            ywhj='ztl007';
                        }else{
                            ywhj='ztl015';
                        }
                        robotAction(d.data[0].ofcode,'FUND','J',d.data[0].secuabbr,'','9905',ywhj,'8','openRobot');

                        /*右上角分享*/
                        /*Com.rightTopBtn('1','',function(){
                            var ofcode = Com.getQueryStringByName('ofcode');
                            var param  = {netAddr:'',financetype:'FUND',token:'',ofcode:ofcode,sharetype:'1',oftype:typechn,ofname:d.data[0].secuabbr};
                            if(typeof shareJsonObj!='undefined'){
                                shareJsonObj.initMethod(param);
                            }
                        });*/
                        //右上角搜索
                        Com.rightTopBtn('4', '1', function () {});

                        /*右上角分享*/
                        Com.rightTopBtn('8','',function(){
                            var ofcode = Com.getQueryStringByName('ofcode');
                            var param  = {netAddr:'',financetype:'FUND',token:'',ofcode:ofcode,sharetype:'1',oftype:typechn,ofname:d.data[0].secuabbr};
                            if(typeof shareJsonObj!='undefined'){
                                shareJsonObj.initMethod(param);
                            }
                        });


                        /*582版本增加定投信息*/
                        if(d.data[0].timeropen=='1'){
                            //支持定投，查定投信息
                            getDtInfo(d.data[0].ofcode,d.data[0].secuid,function(dtinfodata){
                                /*降序排列一下*/
                                dtinfodata.data.sort(comparesort('timeflag'));
                                dtinfodata.data.reverse();
                                fundInfo.dtinfo = dtinfodata.data;
                                var dthtml = $(template('dTdemo', fundInfo));//定投信息
                                $('#dtinfo').html(dthtml);
                            });
                        }
                        if(typeof d.data[0].ofstatus!='undefined' &&d.data[0].ofstatus=='q'){
                            /*认购前*/
                            try
                            {

                                TalkingData.onEventWithLabel("理财-场内外新基金",'场外新基页-认购前');
                            } catch(err) {}

                        }
                        /*591新增引流工具推广订单记录*/
                        promotionHandleInit('J',d.data[0].tacode);
                    }else{
                        Com.showNativeAlert("","暂无数据!",["确定"],'');
                    }
                }
                else if(d.result[0].code == '11' || d.result[0].code == '18' || d.result[0].code == '19'){
                    return false;
                }
                else{
                    Com.showNativeAlert("",d.result[0].msg,["确定"],goHistoryPage);
                }
            },
            "isTradeLogin":false,
            "error":function(){
                mfundCom.ajaxLoaded();
                blackTipBlock('网络不给力',2000);
            }
        });
    };
    fundDataAjax(ofn);
}

/*收益率图表数据*/
function getChartsData(){
    var fundid = Com.getLocalValue('secuid');
    var tradeLoginStatus = false;
    var oftype = fundInfo.data[0].oftype;
    if(!fundid || fundid == ''){
        Com.showNativeAlert("","基金id不能为空!",["确定"],'');
        return false;
    }

    //货币型基金7日年化和万分收益图表
    var fundDataAjax = function(fundid){
        var param = {};
        var whichCanvasTime = dataGlobal.chartsTime;
        var lastDate = mfundCom.dateQueryRate(whichCanvasTime).lastDate;
        var firstDate = mfundCom.dateQueryRate(whichCanvasTime).firstDate;
        param['secuid'] = fundid;
        param['startdate'] = firstDate;
        param['enddate'] = lastDate;
        param['ofcode'] = Com.getQueryStringByName('ofcode');
        /*if(!$('.loadingbox').length){
            Com.ajaxLoading();
        }*/
        Com.ajax({
            "url":Com.getOrigin()+"/gsfinancing/fundinfo/getfundnetvaluelist/1.0",
            "data":param,
            "type":"post",
            "dataType":"json",
            "success":function(d){
                if($('.loadingbox').length){
                    Com.ajaxLoaded();
                }
                if(d.result[0].code == '0'){
                    if(typeof d.data !== 'undefined' && d.data.length != 0){
                        $('#chartsSection').show();
                        $('.det_d_date').show();
                        var chartsType=0;//1:7日年化2:万分收益3:单位净值4:累计净值增长率
                        var oHtml1,oHtml2;
                        if(win_oftype == '4'){
                            if(dataGlobal.whichCharts == '1'){
                                chartsType ='1';
                                //7日年化图表
                                oHtml1 = $(template('fundSevTop', d.data[d.data.length-1]));//头部数据
                                $('#dwjztop').html(oHtml1);
                            }else{
                                //万份收益图表
                                oHtml2 = $(template('fundWfTop', d.data[d.data.length-1]));//头部数据
                                $('#ljjzzzl').html(oHtml2);
                                chartsType ='2';
                            }
                        }else{
                            if(dataGlobal.whichCharts == '1'){
                                chartsType ='3';
                                //单位净值图表
                                oHtml1 = $(template('fundAssTop', d.data[d.data.length-1]));//头部数据
                                $('#dwjztop').html(oHtml1);

                            }else{
                                //累计净值增长率
                                chartsType ='4';
                                oHtml2 = $(template('fundAccTop', d.data[d.data.length-1]));//头部数据
                                $('#ljjzzzl').html(oHtml2);
                            }
                        }
                        /*画图表*/
                        historyRatesCanvas('canvas0',d,chartsType);

                    }else{
                        //图表暂无数据
                        var ofstatus = Com.getLocalValue('ofstatus');
                        if(!$('.nochartsData').length){
                            var nodata = $('<div class="nochartsData"><img src="../../common/images/no_data.png" width="120"><div>暂无数据</div></div>');
                            $('.det_tabs').append(nodata).find('.det_c_des').hide();
                            $('#chartsSection').hide();
                            /*if(ofstatus == 1){
                             mfundCom.showAlert("","","该基金处于募集期!","","确定","","");
                             }*/
                        }
                        return false;
                    }
                }
                else if(d.result[0].code == '11' || d.result[0].code == '18' || d.result[0].code == '19'){
                    return false;
                }
                else{
                    //Com.showNativeAlert("","未查询到相关图表数据!",["确定"],'');
                    Com.showNativeAlert("", d.result[0].msg,["确定"],'');
                }
            },
            "isTradeLogin":tradeLoginStatus,
            "error":function(){
                Com.ajaxLoaded();
                blackTipBlock('网络不给力',2000)
            }
        });
    };
    Com.isTradelogin2(function(){
        tradeLoginStatus = true;
        fundDataAjax(fundid);
    },function(){
        tradeLoginStatus = false;
        fundDataAjax(fundid);
    })
}

//画图表
var chartsobj;

function historyRatesCanvas(obj,d,queryType){

    var unitnetvalue = 'unitnetvalue';
    if(typeof queryType!='undefined' && queryType=='1'){
        //七日年化
        unitnetvalue = 'distributedprofit';
    }
    else if(typeof queryType!='undefined' && queryType=='2'){
        //万分收益
        unitnetvalue = 'nvchangeduetounittrade';
    }
    else if(typeof queryType!='undefined' && queryType=='3'){
        //单位净值
        unitnetvalue = 'unitnetvalue';
    }else{
        //累计净值增长率
        unitnetvalue = 'accrate';
    }

    F.jzzs.echartsOption.xAxis[0].data = [];
    F.jzzs.echartsOption.series[0].data = [];
    if(d.data.length==1){
        F.jzzs.echartsOption.series[0].showSymbol = true;
    }else{
        F.jzzs.echartsOption.series[0].showSymbol = false;
    }
    var firstBuy=[];//第一个买入点
    var firstSale=[];//第一个卖出点
    var firstBuySale=[];//第一个买入卖出点
    var allPoint=[];//买、卖、买/卖点合集
    for (var i=0,len=d.data.length;i<len;i++) {

        if(queryType=='1' || queryType == '4'){
            d.data[i][unitnetvalue]=(d.data[i][unitnetvalue]*100).toFixed(2);
            F.jzzs.echartsOption.yAxis[0].axisLabel.formatter=function(value, index){
                return (value*1).toFixed2(2)+'%';
            }
        }else{
            F.jzzs.echartsOption.yAxis[0].axisLabel.formatter=function(value, index){
                return (value*1).toFixed2(2);
            }
        }

        //x轴日期的第一个值需要居左，需要特殊处理
        if (i==0) {
            if(d.data.length==1){
                F.jzzs.echartsOption.xAxis[0].data[i] = {
                    value:d.data[i].enddate,
                    textStyle:{
                        color:'#8e8e93',
                        fontSize:11,
                        align:'center'
                    }
                };
            }else{
                F.jzzs.echartsOption.xAxis[0].data[i] = {
                    value:d.data[i].enddate,
                    textStyle:{
                        color:'#8e8e93',
                        fontSize:11,
                        align:'left'
                    }
                };
            }
            //x轴日期的最后一个值需要居右
        }else{
            F.jzzs.echartsOption.xAxis[0].data[i] = d.data[i].enddate;
        }
        F.jzzs.echartsOption.series[0].data[i] = d.data[i][unitnetvalue]*1;

        if(d.data[i].bsflag=='0'||d.data[i].bsflag=='1'||d.data[i].bsflag=='2'){
            allPoint.push({"enddate":d.data[i].enddate,"unitnetvalue":d.data[i][unitnetvalue],"bsflag":d.data[i].bsflag});
        }

    }
    F.jzzs.echartsOption.xAxis[0].axisLabel.interval = d.data.length-2;
    //坐标轴在 grid 区域中的分隔线

    F.jzzs.echartsOption.xAxis[0].splitLine.interval = Math.floor(d.data.length-1);

    var olen = d.data.length;

    $('#jz_charts_box').css('display','block').siblings('.chartsNodata').css('display','none');
    var maxValue = Math.max.apply(null, F.jzzs.echartsOption.series[0].data);
    var minValue = Math.min.apply(null, F.jzzs.echartsOption.series[0].data);
    F.jzzs.echartsOption.yAxis[0].min = minValue;
    var symbol,symbolSize,position,symbolOffset;
    var buyPoint=0;
    var salePoint=0;
    var buySalePoint=0;
    //alert(allPoint.length)
    F.jzzs.echartsOption.series[0].markPoint.data=[];
    /*for(var j=0;j<allPoint.length;j++){
        symbol = 'image://../images/charts_buy.png';
        symbolSize=[24,34];
        position=['5','4'];
        symbolOffset=['0','0'];
        if(allPoint[j].bsflag=='0'){
            //买
            if(buyPoint==0){
                buyPoint=1;
                //第一个买入点用文字图片打点
                if(maxValue*1-(allPoint[j].unitnetvalue*1) <= parseFloat((maxValue-minValue)/2)){
                    //箭头向上
                    symbol = 'image://../images/charts_buy_f.png';
                    symbolOffset=['0','40%'];
                    position=['3','9'];
                }
                else{
                    //箭头向下
                    symbol = 'image://../images/charts_buy.png';
                    symbolOffset=['0','-40%'];
                    position=['8','4'];
                }
            }else{
                //除第一个点之外，其余点用小圆点图片打点
                symbol = 'image://../images/buyc.png';
                symbolSize = [6,6];
            }
        }
        if(allPoint[j].bsflag=='1'){
            //卖
            if(salePoint==0){
                salePoint=1;
                //第一个买入点用文字图片打点
                if(maxValue*1-(allPoint[j].unitnetvalue*1) <= parseFloat((maxValue-minValue)/2)){
                    //箭头向上
                    symbol = 'image://../images/charts_sale_f.png';
                    symbolOffset=['0','40%'];
                    position=['3','9'];
                }
                else{
                    //箭头向下
                    symbol = 'image://../images/charts_sale.png';
                    symbolOffset=['0','-40%'];
                    position=['8','4'];
                }
            }else{
                //除第一个点之外，其余点用小圆点图片打点
                symbol = 'image://../images/salec.png';
                symbolSize = [6,6];
            }
        }
        if(allPoint[j].bsflag=='2'){
            //买/卖
            if(buySalePoint==0){
                buySalePoint=1;
                symbolSize=[37,32];
                //第一个买入点用文字图片打点
                if(maxValue*1-(allPoint[j].unitnetvalue*1) <= parseFloat((maxValue-minValue)/2)){
                    //箭头向上
                    symbol = 'image://../images/charts_buy_sale_f.png';
                    symbolOffset=['0','40%'];
                    position=['3','9'];
                }
                else{
                    //箭头向下
                    symbol = 'image://../images/charts_buy_sale.png';
                    symbolOffset=['0','-40%'];
                    position=['8','4'];
                }
            }else{
                //除第一个点之外，其余点用小圆点图片打点
                symbol = 'image://../images/buysalec.png';
                symbolSize = [6,6];
            }
        }

        F.jzzs.echartsOption.series[0].markPoint.data.push({
            name: '',
            symbol:symbol,
            symbolSize:symbolSize,
            symbolOffset:symbolOffset,
            coord: [allPoint[j].enddate,allPoint[j].unitnetvalue],
            label:{
                normal:{
                    position:position,
                    textStyle:{
                        color:'#FFF'
                    },
                    formatter: function (data) {
                        //如果标注的数据显示有问题把该formatter去掉
                        return '';
                    }
                }
            }
        });
    }*/
    chartsobj = echarts.init(document.getElementById(obj));
    chartsobj.setOption(F.jzzs.echartsOption);
}

//基金概况、费率说明、基金持仓、基金公告
$('.d_o_link').on('tap',function(){
    if($(this).hasClass('on')){
        return;
    }

    var $obj = $('.d_o_link');
    var $tabs = $('.d_o_tabs');
    var oindex = $obj.index($(this));

    $obj.removeClass('on').eq(oindex).addClass('on');
    $tabs.hide().eq(oindex).show();

    //定位到该位置
    gotoThisPos();

    /*if(oindex == 2){
        //拿基金持仓的数据
        getFundInte();
    }
    else if(oindex == 3){
        //公告列表
        mfundCom.setLocalValue('noticePage',0);
        getNoticeList();
    }
    else if(oindex == 1){
        //费率
        getFl()
    }else if(oindex == 0){
        //基金概况
        /!*加载完之后定位到该位置*!/
        gotoThisPos();
    }*/

});

//单位净值，累计净值增长率
$(document).on('tap','.tabslink',function(){
    var fdt = getGlobalFundData();
    var oftype=fdt.oftype;
    if($(this).hasClass('on')){
        return false;
    }
    var $obj = $('.tabslink');
    var oindex = $obj.index($(this));
    if(oftype=='4'){
        if(oindex=='0'){
            try
            {
                TalkingData.onEventWithLabel('开放式基金详情页','老基金页-货币型-七日年化Tab');
            } catch(err) {}
        }else{
            try
            {
                TalkingData.onEventWithLabel('开放式基金详情页','老基金页-货币型-万分收益Tab');
            } catch(err) {}
        }
    }
    $obj.removeClass('on').eq(oindex).addClass('on');
    $('.det_tabs').hide().eq(oindex).show();
    $('.hbmore').addClass('displaynone').eq(oindex).removeClass('displaynone');
    if(oindex == 0){
        dataGlobal.whichCharts = '1';
    }else{
        dataGlobal.whichCharts = '2';
    }
    getChartsData();
});

//近N个月时间维度(货币型基金)
$(document).on('click','.chartstimemenu',function(){
    if($(this).hasClass('on')){
        return false;
    }
    var obj = $('.chartstimemenu');
    var oindex = obj.index($(this));
    obj.removeClass('on').eq(oindex).addClass('on');
    switch (oindex){
        case 0:
            dataGlobal.chartsTime = '1';
            break;
        case 1:
            dataGlobal.chartsTime = '3';
            break;
        case 2:
            dataGlobal.chartsTime = '6';
            break;
        default :
            dataGlobal.chartsTime = '12';
    }
    getChartsData();
});

//近N个月时间维度(非货币型基金-业绩走势)
$(document).on('click','.yjzsmenuchoose',function(){
    if($(this).hasClass('on')){
        return false;
    }
    var tdstr='';
    var obj = $('.yjzsmenuchoose');
    var oindex = obj.index($(this));
    var choosetime='';
    var funddt = getGlobalFundData();
    var oftypechn = funddt.oftypechn;
    obj.removeClass('on').eq(oindex).addClass('on');
    switch (oindex){
        case 0:
            tdstr='老基金页-'+oftypechn+'-业绩走势-近1月Tab点击次数';
            choosetime = '1m';
            break;
        case 1:
            tdstr='老基金页-'+oftypechn+'-业绩走势-近3月Tab点击次数';
            choosetime = '3m';
            break;
        case 2:
            tdstr='老基金页-'+oftypechn+'-业绩走势-近6月Tab点击次数';
            choosetime = '6m';
            break;
        case 3:
            tdstr='老基金页-'+oftypechn+'-业绩走势-近1年Tab点击次数';
            choosetime = '1y';
            break;
        default :
            tdstr='老基金页-'+oftypechn+'-业绩走势-近3年Tab点击次数';
            choosetime = '3y';
            break;
    }
    try
    {
        TalkingData.onEventWithLabel('开放式基金详情页',tdstr);
    } catch(err) {}
    dataObj.choosetime = choosetime;
    yjChartsAjax(choosetime);
});

//添加或删除自选
function addOrDelZx($this){
    //var ison = $this.find('.operzxg').html();
    var ison = $this.find('.operzxg').hasClass('addzx');
    var ofn = Com.getQueryStringByName('ofcode');
    //mfundCom.ajaxLoading();
    if(!ison){
        //添加自选
        Com.addZxFund(ofn,zxAddCallback);
    }else{
        //删除自选
        Com.delZxFund(ofn,zxDelCallback);
    }
}

//是否是自选，native回调
function isZxJsCallback(nativeJson){
    if(nativeJson === 'string'){
        nativeJson = JSON.parse(nativeJson);
    }
    if(nativeJson.isAdded == 'true' || nativeJson.isAdded == true){
        //是自选，显示"-"
        //$('.operzxg').html('已加');
        $('.operzxg').addClass('addzx');
    }else{
        //不是自选，显示"+"
        //$('.operzxg').html('+');
        $('.operzxg').removeClass('addzx');
    }
}

//添加自选回调函数
function zxAddCallback(nativeJson){

    if(nativeJson === 'string'){
        nativeJson = JSON.parse(nativeJson);
    }
    if(nativeJson.addResult == 'true' || nativeJson.addResult == true){

        var oftypechn=getGlobalFundData().oftypechn;
        var ofcode=getGlobalFundData().ofcode;
        var ofstatus=getGlobalFundData().ofstatus;
        if(ofstatus=='1'){
            try
            {
                TalkingData.onEventWithLabel("开放式基金详情页",'新发基金页-'+oftypechn+'-'+ofcode+'-加自选');
            } catch(err) {}
        }else{
            try
            {
                TalkingData.onEventWithLabel("开放式基金详情页",'老基金页-'+oftypechn+'-加自选');
            } catch(err) {}
        }

        //$('.zxlink').show().removeClass('on');
        //$('.operzxg').html('已加');
        $('.operzxg').addClass('addzx');
    }else{
        Com.showNativeAlert("",nativeJson.errorMessage,["确定"],'');
        return false;
    }
}

//删除自选回调函数
function zxDelCallback(nativeJson){
    if(nativeJson === 'string'){
        nativeJson = JSON.parse(nativeJson);
    }
    if(nativeJson.deletedResult == 'true' || nativeJson.deletedResult == true){
        //$('.zxlink').show().addClass('on');
        //$('.operzxg').html('+');
        $('.operzxg').removeClass('addzx');
    }else{
        Com.showNativeAlert("",nativeJson.errorMessage,["确定"],'');
    }
}

//点击基金概况、费率、持仓、公告定位到相关位置
function gotoThisPos(){
    var scrollDisPos = $('.det_other').offset().top;
    $.scrollTo({
        endY: scrollDisPos,
        duration: 500,
        callback: function() {}
    });
}

/****基金盈亏接入后新增***/
template.helper('dateFormat', function (date, format) {
    if (typeof date == "string") {
        if (date.indexOf('-') > -1) {
            date= new Date(date.split('-')[0],date.split('-')[1]*1-1,date.split('-')[2]);
        }else{
            date= new Date(date.substring(0,4),date.substring(4,6)*1-1,date.substring(6,8));
        }
    }
    date = new Date(date);

    var map = {
        "M": date.getMonth() + 1, //月份
        "d": date.getDate(), //日
        "h": date.getHours(), //小时
        "m": date.getMinutes(), //分
        "s": date.getSeconds(), //秒
        "q": Math.floor((date.getMonth() + 3) / 3), //季度
        "S": date.getMilliseconds() //毫秒
    };
    format = format.replace(/([yMdhmsqS])+/g, function(all, t){
        var v = map[t];
        if(v !== undefined){
            if(all.length > 1){
                v = '0' + v;
                v = v.substr(v.length-2);
            }
            return v;
        }
        else if(t === 'y'){
            return (date.getFullYear() + '').substr(4 - all.length);
        }
        return all;
    });
    return format;
});



var F = F||{}; //定义一个全局对象作为命名空间
F.jzzs=F.jzzs||{};
//曲线
F.jzzs.echartsOption = {
    title: {
        show:false,
        padding:0,
        text: '收益率'
    },
    legend: {
        show:false
    },
    grid: {
        left: '0',
        right: '0',
        bottom: '10px',
        top:'8px',
        containLabel: true
    },
    xAxis : [
        {
            type : 'category',
            boundaryGap : false,
            data : [],
            axisLabel:{
                textStyle:{
                    color:'#8e8e93',
                    fontSize:11,
                    align:'right'
                },
                interval:0,
                margin:15,
                formatter: function (value, index) {
                    return value;
                }
            },
            axisLine: {            // 坐标轴线
                lineStyle: {       // 属性lineStyle控制线条样式
                    color: '#f6f6f7'
                },
                show:true
            },
            axisTick: {            // 坐标刻度
                show:false
            },
            animation:false,
            splitLine: {           // 分隔线
                interval:30,
                show:true,
                lineStyle: {       // 属性lineStyle（详见lineStyle）控制线条样式
                    color: ['#f6f6f7']
                }
            }
        }
    ],
    yAxis : [
        {
            type : 'value',
            splitLine: {           // 分隔线
                lineStyle: {       // 属性lineStyle（详见lineStyle）控制线条样式
                    color: ['#f6f6f7'],
                    type:'dashed'  //'solid'  'dashed'  'dotted'
                }
            },
            axisLine: {            // 坐标轴线
                show:false,
                lineStyle: {       // 属性lineStyle控制线条样式
                    color: '#f6f6f7'
                }
            },
            axisLabel:{
                // inside:true,
                textStyle:{
                    color:'#8e8e93',
                    baseline:'middle',
                    fontSize:11
                },
                formatter: function (value, index) {
                    return (value*1).toFixed2(2);
                }
            },
            axisTick:{
                show:false
            },
            animation:false,
            splitNumber:4
        }
    ],
    series : [
        {
            name:'净值走势',
            type:'line',
            // stack: '总量',
            data:[],
            /*areaStyle: {
                normal: {
                    color:'rgba(255,242,229,.3)'
                },
                smooth:true
            },*/
            lineStyle:{
                normal:{
                    width:1,
                    color:'#589dfc'
                }
            },
            animation:false,
            itemStyle:{
                normal : {
                    color:'#FD5656',
                    lineStyle:{
                        color:'#FD5656'
                    }
                }
            },
            showSymbol :false,
            markPoint : {
                symbolOffset:['-40%','-70%'],
                itemStyle: {
                    normal: {
                        color:'#47A5F4',
                        borderColor:'rgba(59,159,243,0.2)',
                        borderWidth :'5'
                    }
                },
                label:{
                    normal:{
                        position:['8','3'],
                        textStyle:{
                            color:'#FFF'
                        }
                    }
                },
                data: [
                    {
                        name: '买',
                        symbol:'image://../images/charts_buy.png',
                        symbolSize:[24,34],
                        coord: [],
                        // value:'3.02%',
                        label:{
                            normal:{
                                position:['5','4'],
                                textStyle:{
                                    color:'#FFF'
                                },
                                formatter: function (data) {
                                    //如果标注的数据显示有问题把该formatter去掉
                                    return '';
                                }
                            }
                        }
                    },
                    {
                        name: '卖',
                        symbol:'image://../images/charts_sale.png',
                        symbolSize:[24,34],
                        coord: [],
                        label:{
                            normal:{
                                position:['5','4'],
                                textStyle:{
                                    color:'#FFF'
                                },
                                formatter: function (data) {
                                    //如果标注的数据显示有问题把该formatter去掉
                                    return '';
                                }
                            }
                        }
                    },
                    {
                        name: '买/卖',
                        symbol:'image://../images/charts_buy_sale.png',
                        symbolSize:[37,32],
                        coord: [],
                        // value:'3.02%',
                        label:{
                            normal:{
                                position:['5','4'],
                                textStyle:{
                                    color:'#FFF'
                                },
                                formatter: function (data) {
                                    //如果标注的数据显示有问题把该formatter去掉
                                    return '';
                                }
                            }
                        }
                    }
                ]
            }
        }
    ]
};
function fundDetailsInit(){
    //隐藏顶部taps
    Com.hideNativeTitleTaps();

    //看当前地址是否有经纪人id，如果有则需要记录
    brokerHandleInit('J');

    getFundDetails();//基金详情数据(基础数据、基金概况)

    $(window).on('scroll',function(){
        var oheight = $(document).height();
        var wheight = $(window).height();
        var wintop = $(window).scrollTop();
        var activemenu = $('.each_fd_menu.on').attr('tabname');
        //console.log($(window).scrollTop()+'||||document'+oheight+'|window'+wheight);
        if(wintop+wheight >= oheight-50){
            /*认购前的基金并且没设置认购提醒的。提示栏一直显示*/
            if(typeof fundInfo!='undefined'){
                if((fundInfo.data[0].ofstatus=='q'&&dataObj.isreminded)||fundInfo.data[0].ofstatus!='q'){
                    $('.flbox').css('display','none');
                }
            }


        }else{
            if(activemenu!='jjjd'){
                $('.flbox').css('display','block');
            }

        }
    });


    //购买或定投（普通定投）
    $(document).on('click','.gobuy',function(e){
        var fundCode = $(this).parents('tr').attr('ofn');
        var fundCompanyCode = $(this).parents('tr').attr('tan');
        var $this = $(this);

        //购买处理
        Com.actionLogin(clickHandle);

        function clickHandle(){
            if($this.hasClass('fbuy')){

                var oftypechn=getGlobalFundData().oftypechn;
                var ofcode=getGlobalFundData().ofcode;
                var ofstatus=getGlobalFundData().ofstatus;
                if(ofstatus=='1'){
                    try
                    {
                        TalkingData.onEventWithLabel("开放式基金详情页",'新发基金页-'+oftypechn+'-'+ofcode+'-立即认购');
                    } catch(err) {}
                }else{
                    try
                    {
                        TalkingData.onEventWithLabel("开放式基金详情页",'老基金页-'+oftypechn+'-购买');
                    } catch(err) {}
                }
                /*578购买前置逻辑判断下沉到购买页面*/
                //fund_checkUserCanBuy(fundCode,fundCompanyCode,$this,'0');//购买
                Com.newWebViewOpenPage('',{"pageUrl":Com.getOrigin()+'/asset/mfund/pages/fund_buy.html?ofcode='+ofcode+'&tan='+fundCompanyCode,"weburl":Com.getOrigin()+'/asset/mfund/pages/fund_buy.html?ofcode='+ofcode+'&tan='+fundCompanyCode});

            }else{
                //fund_checkUserCanBuy(fundCode,fundCompanyCode,$this,'1');//定投
                //点击了定投按钮
                //$('#itc_panel').css('display','block');
                /*582*/
                var oftype = $this.attr('oftype');
                var isindex = $this.attr('isindex');
                if( oftype=='1' || oftype=='2' || isindex=='1'){
                    //支持智能定投
                    Com.actionLogin(function(){
                        intellect_checkUserCanBuy(fundCode,fundCompanyCode,$this,'1');
                    });
                }else{
                    Com.actionLogin(function(){
                        fund_checkUserCanBuy(fundCode,fundCompanyCode,$this,'1');
                    });
                }
            }
        }


    });

    //点击普通定投
    $(document).on('click','#pt_fi',function(e){
        var fundCode = $(this).attr('ofn');
        var fundCompanyCode = $(this).attr('tan');
        var $this = $(this);
        $('#itc_panel').css('display','none');
        //定投处理
        var ptdtHandle = function(){
            fund_checkUserCanBuy(fundCode,fundCompanyCode,$this,'1');
        };
        Com.actionLogin(ptdtHandle);
    });


    //点击智能定投
    $(document).on('click','#itc_fi',function(e){
        var fundCode = $(this).attr('ofn');
        var fundCompanyCode = $(this).attr('tan');
        var $this = $(this);
        $('#itc_panel').css('display','none');
        //定投处理
        var ptdtHandle = function(){
            intellect_checkUserCanBuy(fundCode,fundCompanyCode,$this,'1');//定投
        };
        Com.actionLogin(ptdtHandle);
    });

    //点击取消(关闭定投浮层)
    $(document).on('click','#choose_cancel',function(e){
        $('#itc_panel').css('display','none');
    });

    //月薪理财产品池过来的只有定投按钮，定投跳转到月薪理财定投
    $(document).on('click','.goyxlc',function(e){
        var fundCode = $(this).parents('tr').attr('ofn');
        var fundCompanyCode = $(this).parents('tr').attr('tan');
        var $this = $(this);
        //去月薪理财的定投
        Com.actionLogin(dtFiScenePage);

        function dtFiScenePage(){
            fund_scene_checkUserCanBuy(fundCode,fundCompanyCode,$this,'1');
        }
    });


    //打开养老型基金风险揭示
    $(document).on('click','#risktips',function(){
        var that = $(this);
        versionJudgment('4.5.1',function(){

            var oftypechn=getGlobalFundData().oftypechn;
            var ofcode=getGlobalFundData().ofcode;
            var ofstatus=getGlobalFundData().ofstatus;
            if(ofstatus=='1'){
                try
                {
                    TalkingData.onEventWithLabel("开放式基金详情页",'新发基金页-'+oftypechn+'-'+ofcode+'-基金概况-风险揭示');
                } catch(err) {}
            }else{
                try
                {
                    TalkingData.onEventWithLabel("开放式基金详情页",'老基金页-'+oftypechn+'-基金概况-风险揭示');
                } catch(err) {}
            }

            //大于等于4.5.1正常加载pdf
            var url = that.attr('_href');
            Com.downloadPdf(url,function(){
                //pdf地址为空时触发此回调
                Com.nativeToast('加载内容异常，请稍后重试','0');
            });
        },function(){
            //小于4.5.1
            Com.showNativeAlert('', '请升级至最新版本查阅风险协议',['确定'],'');
        });
    });

    //添加删除自选
    $(document).on('click','#operzxfund',function(){
        addOrDelZx($(this));
    });


    //native累计净值增长率弹框
    $(document).on('tap','#nativeshow_zzl',function(){
        Com.showScreenMask('累计净值增长率','累计净值增长率=(当前累计净值-期初累计净值)/期初累计净值');
    });

    //native近三个月收益率弹框
    $(document).on('tap','#nativeshow_tsy',function(){
        Com.showScreenMask('近3月收益率','近3月收益率=(当前单位净值-期初单位净值)/期初单位净值*100%');
    });

    //基金详情页面跳转
    $(document).on('click','.mfund_opennewpage',function(){
        var ourl = $(this).attr('_href');
        if(ourl && ourl != ''){
            Com.newWebViewOpenPage('',{"pageUrl":Com.getOrigin()+'/asset/'+ourl,"weburl":Com.getOrigin()+'/asset/'+ourl});
        }
    });

    //基金扫描跳转
    $(document).on('click','#jjsmgo',function(){
        try
        {
            TalkingData.onEventWithLabel("理财-基金扫描",'基金扫描-基金详情页入口');
        }
        catch(err) {}
        var ourl = $(this).attr('_href');
        if(ourl && ourl != ''){
            Com.newWebViewOpenPage('',{"pageUrl":Com.getOrigin()+'/asset/'+ourl,"weburl":Com.getOrigin()+'/asset/'+ourl});
        }
    });

    //设置标题
    //Com.setWebviewStockTitle('',{"stockName":d.data1[0].ofname,"stockCode":d.data1[0].ofcode,"bgColor":"589DFC"});
    Com.setWebviewTitle('',{"title":document.title,"bgColor":"589DFC"},true);


    //新基金-基金公司基金经理切换
    $(document).on('click','.newfundmenu',function(){
        if($(this).hasClass('on')){
            return;
        }
        var oindex = $('.newfundmenu').index($(this));
        var typestr=fundInfo.data[0].oftype;
        var tabname = $(this).attr('tabname');

        if(fundInfo.data[0].isindex=='1'){
            //优先判断是不是指数型
            typestr='8';
        }
        var typestrchn=oftypechn(typestr);
        if(tabname == 'jjjl'){
            $('#jjgkbox').css('display','block');
            try
            {

                TalkingData.onEventWithLabel("开放式基金详情页",'新发基金页-'+typestrchn+'-'+ fundInfo.data[0].ofcode+'-基金经理Tab');
            } catch(err) {}
        }
        else if(tabname == 'jjgs'){
            $('#jjgkbox').css('display','block');
            try
            {

                TalkingData.onEventWithLabel("开放式基金详情页",'新发基金页-'+typestrchn+'-'+ fundInfo.data[0].ofcode+'-基金公司Tab');
            } catch(err) {}
        }
        else if(tabname == 'jjjd'){
            $('#jjgkbox').css('display','none');
            $('.flbox').css('display','none');
        }
        $('.newfundmenu').removeClass('on').eq(oindex).addClass('on');
        $('.mgtabs').css('display','none').eq(oindex).css('display','block');
    });

    //跳转基金视频讲解
    $(document).on('click','.gojjvideo',function(){
        var liveid = Com.getQueryStringByName('liveid');
        var livetype = Com.getQueryStringByName('livetype');
        var url = '';
        if(livetype == '1'){
            url = Com.getOrigin()+'/asset/invest_college/dist/pages/live.html?id='+liveid;
        }else if(livetype == '2'){
            url = Com.getOrigin()+'/asset/invest_college/dist/pages/video.html?id='+liveid+'&from=lesson&shareFlag=1';
        }else{
            url = Com.getOrigin()+'/asset/invest_college/dist/pages/video.html?id='+liveid+'&from=lesson';
        }
        Com.newWebViewOpenPage('',{"pageUrl":url,"weburl":url});
        try
        {
            TalkingData.onEventWithLabel("理财",'理财产品详情页-基金详情-视频入口');
        } catch(err) {}
    });

    //跳转到基金概况
    $(document).on('click','.gojjgk',function(){
        var oftypechn=getGlobalFundData().oftypechn;
        var oftype=getGlobalFundData().oftype;
        var ofcode=getGlobalFundData().ofcode;
        var ofstatus=getGlobalFundData().ofstatus;
        if(ofstatus=='1'){
            try
            {
                TalkingData.onEventWithLabel("开放式基金详情页",'新发基金页-'+oftypechn+'-'+ofcode+'-基金概况-投资说明');
            } catch(err) {}
        }else{
            if(oftype=='4'){
                try
                {
                    TalkingData.onEventWithLabel("开放式基金详情页",'老基金页-货币型-基金概况-更多概况');
                } catch(err) {}
            }else{
                try
                {
                    TalkingData.onEventWithLabel("开放式基金详情页",'老基金页-'+oftypechn+'-基金概况-更多概况');
                } catch(err) {}
            }

        }
        var param=joinParamForOpenUrl();
        Com.newWebViewOpenPage('',{"pageUrl":Com.getOrigin()+'/asset/mfund/pages/fund_details_jjgk_gk.html'+param,"weburl":Com.getOrigin()+'/asset/mfund/pages/fund_details_jjgk_gk.html'+param});
    });

    //跳转到基金公告
    $(document).on('click','.gojjgg',function(){
        var oftypechn=getGlobalFundData().oftypechn;
        var ofcode=getGlobalFundData().ofcode;
        var ofstatus=getGlobalFundData().ofstatus;

        if(ofstatus=='1'){
            try
            {
                TalkingData.onEventWithLabel("开放式基金详情页",'新发基金页-'+oftypechn+'-'+ofcode+'-基金概况-基金公告');
            } catch(err) {}
        }
        var param=joinParamForOpenUrl();
        Com.newWebViewOpenPage('',{"pageUrl":Com.getOrigin()+'/asset/mfund/pages/fund_details_jjgk_gg.html'+param,"weburl":Com.getOrigin()+'/asset/mfund/pages/fund_details_jjgk_gg.html'+param});
    });

    //跳转到费率详情
    $(document).on('click','.goflxq',function(){
        var oftypechn=getGlobalFundData().oftypechn;
        var oftype=getGlobalFundData().oftype;
        var ofcode=getGlobalFundData().ofcode;
        var ofstatus=getGlobalFundData().ofstatus;
        if(ofstatus=='1'){
            try
            {
                TalkingData.onEventWithLabel("开放式基金详情页",'新发基金页-'+oftypechn+'-'+ofcode+'-交易信息-费率更多信息');
            } catch(err) {}
        }else{
            if(oftype=='4'){
                try
                {
                    TalkingData.onEventWithLabel("开放式基金详情页",'老基金页-货币型-交易信息-费率更多信息');
                } catch(err) {}
            }else{
                try
                {
                    TalkingData.onEventWithLabel("开放式基金详情页",'老基金页-'+oftypechn+'-交易信息-费率更多信息');
                } catch(err) {}
            }

        }
        var param=joinParamForOpenUrl();
        Com.newWebViewOpenPage('',{"pageUrl":Com.getOrigin()+'/asset/mfund/pages/fund_details_flxq.html'+param,"weburl":Com.getOrigin()+'/asset/mfund/pages/fund_details_flxq.html'+param});
    });


    //跳转到分红
    $(document).on('click','.gojjfh',function(){
        var param=joinParamForOpenUrl();
        Com.newWebViewOpenPage('',{"pageUrl":Com.getOrigin()+'/asset/mfund/pages/fund_details_jjgk_fh.html'+param,"weburl":Com.getOrigin()+'/asset/mfund/pages/fund_details_jjgk_fh.html'+param});
    });

    //跳转到业绩详情
    $(document).on('click','.yjxqgo',function(){
        var oftypechn=getGlobalFundData().oftypechn;
        try
        {
            TalkingData.onEventWithLabel("开放式基金详情页",'老基金页-'+oftypechn+'-业绩净值详情');
        } catch(err) {}
        var param=joinParamForOpenUrl();
        Com.newWebViewOpenPage('',{"pageUrl":Com.getOrigin()+'/asset/mfund/pages/fund_details_jjbx.html'+param,"weburl":Com.getOrigin()+'/asset/mfund/pages/fund_details_jjbx.html'+param});
    });


    //跳转到基金经理详情
    $(document).on('click','.managedetails',function(){
        var oftypechn=getGlobalFundData().oftypechn;
        var oftype=getGlobalFundData().oftype;
        var ofcode=getGlobalFundData().ofcode;
        var ofstatus=getGlobalFundData().ofstatus;
        if(ofstatus=='1'){
            try
            {
                TalkingData.onEventWithLabel("开放式基金详情页",'新发基金页-'+oftypechn+'-'+ofcode+'-基金经理详情');
            } catch(err) {}
        }else{
            if($(this).hasClass('jjjlgk')){
                if(oftype=='4'){
                    try
                    {
                        TalkingData.onEventWithLabel("开放式基金详情页",'老基金页-货币型-基金概况-基金经理');
                    } catch(err) {}
                }else{
                    try
                    {
                        TalkingData.onEventWithLabel("开放式基金详情页",'老基金页-'+oftypechn+'-基金概况-基金经理');
                    } catch(err) {}
                }

            }else{
                try
                {
                    TalkingData.onEventWithLabel("开放式基金详情页",'老基金页-'+oftypechn+'-基金经理详情');
                } catch(err) {}
            }
        }

        var param=joinParamForOpenUrl();
        Com.newWebViewOpenPage('',{"pageUrl":Com.getOrigin()+'/asset/mfund/pages/fund_details_jjjl.html'+param,"weburl":Com.getOrigin()+'/asset/mfund/pages/fund_details_jjjl.html'+param});
    });

    //跳转到基金公司详情
    $(document).on('click','.jjgsgo',function(){
        var oftypechn=getGlobalFundData().oftypechn;
        var oftype=getGlobalFundData().oftype;
        var ofcode=getGlobalFundData().ofcode;
        var ofstatus=getGlobalFundData().ofstatus;
        if(ofstatus=='1'){
            try
            {
                TalkingData.onEventWithLabel("开放式基金详情页",'新发基金页-'+oftypechn+'-'+ofcode+'-基金公司详情');
            } catch(err) {}
        }else{
            if(oftype=='4'){
                try
                {
                    TalkingData.onEventWithLabel("开放式基金详情页",'老基金页-货币型-基金概况-基金公司');
                } catch(err) {}
            }else{
                try
                {
                    TalkingData.onEventWithLabel("开放式基金详情页",'老基金页-'+oftypechn+'-基金概况-基金公司');
                } catch(err) {}
            }

        }
        var param=joinParamForOpenUrl();
        Com.newWebViewOpenPage('',{"pageUrl":Com.getOrigin()+'/asset/mfund/pages/fund_details_jjgs.html'+param,"weburl":Com.getOrigin()+'/asset/mfund/pages/fund_details_jjgs.html'+param});
    });


    //基金解读入口跳转到基金运营专题模板
    $(document).on('click','#jjmbgo',function(){
        var ofcode=Com.getQueryStringByName('ofcode');
        var oftypechn=getGlobalFundData().oftypechn;
        try
        {
            TalkingData.onEventWithLabel("开放式基金详情页",'新发基金页-'+oftypechn+'-'+ofcode+'-基金概况-基金解读');
        } catch(err) {}

        Com.newWebViewOpenPage('',{"pageUrl":Com.getOrigin()+'/asset/goldsun_mlc/topic/pages/fund.html?ofcode='+ofcode,"weburl":Com.getOrigin()+'/asset/goldsun_mlc/topic/pages/fund.html?ofcode='+ofcode});
    });

    //基金概况---资产配置
    $(document).on('click','.gk_zcpzgo',function(){
        var oftypechn=getGlobalFundData().oftypechn;
        try
        {
            TalkingData.onEventWithLabel("开放式基金详情页",'老基金页-'+oftypechn+'-重仓股投资组合详情');
        } catch(err) {}
        var param=joinParamForOpenUrl();
        Com.newWebViewOpenPage('',{"pageUrl":Com.getOrigin()+'/asset/mfund/pages/fund_details_jjgk_pz.html'+param,"weburl":Com.getOrigin()+'/asset/mfund/pages/fund_details_jjgk_pz.html'+param});
    });

    //基金概况---规模
    $(document).on('click','.gk_gojjgm',function(){
        var oftypechn=getGlobalFundData().oftypechn;
        var oftype=getGlobalFundData().oftype;
        if(oftype=='4'){
            try
            {
                TalkingData.onEventWithLabel("开放式基金详情页",'老基金页-货币型-基金概况-规模详情');
            } catch(err) {}
        }else{
            try
            {
                TalkingData.onEventWithLabel("开放式基金详情页",'老基金页-'+oftypechn+'-基金概况-基金规模');
            } catch(err) {}
        }

        var param=joinParamForOpenUrl();
        Com.newWebViewOpenPage('',{"pageUrl":Com.getOrigin()+'/asset/mfund/pages/fund_details_jjgk_gm.html'+param,"weburl":Com.getOrigin()+'/asset/mfund/pages/fund_details_jjgk_gm.html'+param});
    });

    //货币型基金---基金表现(七日年化/万份收益)
    $(document).on('click','.ratesevendetails',function(){
        try
        {
            TalkingData.onEventWithLabel("开放式基金详情页",'老基金页-货币型-年化万份收益');
        } catch(err) {}
        var param=joinParamForOpenUrl();
        Com.newWebViewOpenPage('',{"pageUrl":Com.getOrigin()+'/asset/mfund/pages/fund_details_7dayrate.html'+param,"weburl":Com.getOrigin()+'/asset/mfund/pages/fund_details_7dayrate.html'+param});
    });

    //跟踪标的---跳转到指数详情
    $(document).on('click','.jzwdgo',function(){
        var oftypechn=getGlobalFundData().oftypechn;
        try
        {
            TalkingData.onEventWithLabel("开放式基金详情页",'老基金页-'+oftypechn+'-指数估值详情');
            TalkingData && TalkingData.onEventWithLabel('理财-指数投资', '基金详情页-指数型-跟踪指数');
        } catch(err) {}
        var secuid=$(this).attr('secuid');
        Com.newWebViewOpenPage('',{"pageUrl":Com.getOrigin()+'/asset/mfvaluedp/pages/index_details.html?secuid='+secuid,"weburl":Com.getOrigin()+'/asset/mfvaluedp/pages/index_details.html?secuid='+secuid});
    });

    //估值区间----说明
    $(document).on('click','.gztips',function(){
        var clientType =Com.clientType();
        var splitStr='<br/>';
        if(clientType=='ios'){
            splitStr='\n';
        }
        TalkingData && TalkingData.onEventWithLabel('理财-指数投资', '基金详情页-指数型-跟踪指数');
        Com.showScreenMask('估值区间','以指数市盈率为基准，计算当前市盈率处于最近5年（不足5年的，取最大可取长度数据进行统计）的百分位，得出的估值区间。'+splitStr+splitStr+'区间百分位（S)与估值区间对应一览：'+splitStr+'S≤20%：低估区'+splitStr+'20%< S ≤40%：较低估区'+splitStr+'40%< S ≤60%：正常区'+splitStr+'60%< S ≤80%：较高估区'+splitStr+'80%< S ≤100%：高估区'+splitStr+splitStr+'不同统计区间，估值百分位可能存在较大差异。'+splitStr+'不同指数可能适用不同的估值指标进行评价。'+splitStr+'数据均来源于恒生聚源、wind等合法公开的信息渠道，我公司对这些信息的准确性及完整性不做任何保证。投资有风险，资讯仅供参考 ，不作为具体推荐 ，投资者应自主做出投资决策并自行承担投资风险。');
    });

    //新基金--基金公司----柱状图业绩说明
    $(document).on('click','.jjgsglyj',function(){
        Com.showScreenMask('基金管理业绩','按照阶段收益在同类基金中的排名，将基金分为4档，每档包含约四分之一的基金，按相对排名从高到低依次对应：优秀、良好、一般、较差。统计各业绩档次中管理的基金数量进行展示。\n请特别注意，采用不同分类标准，同类基金数据可能不同，其排名会存在差异。排名根据WIND开放式基金二级分类计算，仅供参考。');
    });

    //基金经理雷达图---说明
    $(document).on('click','.mgntipsicon',function(){
        Com.showScreenMask('基金经理','1、本基金任职回报排名：本基金经理任职本基金期间的基金收益的同类排名，相对业绩越好，排名得分越高。(若任职期限较短，参考意义较低。) \n2、本基金风险控制排名：本基金经理任职本基金期间的基金最大回撤的同类排名，相对风险越低，排名得分越高。(若任职期限较短，参考意义较低。)\n3、基金经理历任回报排名：本基金经理管理的基金(含已离任)，剔除任职不足6个月基金，剩余基金任期回报排名的平均数。平均数越小，过往业绩越好。平均数越大，过往业绩越好。\n4、管理经验排名：基金经理第一次任职基金经理以来，至今实际管理天数的排名。管理天数越长，排名得分越高。\n5、业绩稳定性：过去8个季度，基金经理管理的所有基金，业绩排名同类前50%的季度数量比例。');
    });
    //产品月报
    $(document).on('click', '.goto-product-news', function() {
        var url = Com.getOrigin() + '/asset/goldsun_mlc/financing_index/dist/pages/product_news.html?ofcode=' + getGlobalFundData().ofcode
        Com.newWebViewOpenPage('',{"pageUrl": url, "weburl": url});

    });


    //点击黑色浮层隐藏定投浮层
    $(document).on('tap','#itc_panel',function(e){
        var el = $(e.target);
        var elClass = el.attr('class');
        if(elClass.indexOf('itc_panel_box')!='-1'){
            $('#itc_panel').css('display','none');
        }
    });

    //跳转到财富号动态详情
    $(document).on('click','.gocfhxq',function(e){
        var companyid = $(this).attr('companyid');
        var newsid = $(this).attr('newsid');
        //TalkingData && TalkingData.onEventWithLabel('理财-公募基金-财富号', '理财产品详情页-基金详情-财富号');
        Com.newWebViewOpenPage('',{"pageUrl":Com.getOrigin()+'/asset/goldsun_mlc/cfh/dist/pages/news_details.html?companyid='+companyid+'&newsid='+newsid+'&pagefrom=jjdetails',"weburl":Com.getOrigin()+'/asset/goldsun_mlc/cfh/dist/pages/news_details.html?companyid='+companyid+'&newsid='+newsid+'&pagefrom=jjdetails'});
    });

    //跳转到财富号详情
    $(document).on('click','#cfhgo',function(e){
        var companyid = $(this).attr('companyid');
        TalkingData && TalkingData.onEventWithLabel('理财', '理财产品详情页-基金详情-财富号');
        Com.newWebViewOpenPage('',{"pageUrl":Com.getOrigin()+'/asset/goldsun_mlc/cfh/dist/pages/index.html?companyid='+companyid+'&pagefrom=jjdetails',"weburl":Com.getOrigin()+'/asset/goldsun_mlc/cfh/dist/pages/index.html?companyid='+companyid+'&pagefrom=jjdetails'});
    });


    //交易信息说明
    $(document).on('click','.jyxxshow',function(){
        Com.showScreenMask('交易信息说明','基金交易流程具体日期、货币结转方式、理财型基金锁定期等信息仅供参考，具体以基金公司确认为准。');
    });

    splitStr();
    //定投年均复合收益率说明
    $(document).on('click','#dtfhsm',function(){
        Com.showScreenMask('收益率说明','按每月投资一次来计算，不包含交易手续费。'+dataObj.splitStr+'智能定投收益率计算公式'+dataObj.splitStr+'C1*(1+r/12) ^n +C2*(1+r/12)^(n-1)+... '+dataObj.splitStr+'+Cn(1+r/12) ^1=NAVn'+dataObj.splitStr+dataObj.splitStr+'（n为投资期数，NAVn为第n月期末市值，r为年化收益率。Ci为第i期投入金额）'+dataObj.splitStr+dataObj.splitStr+'因为智能定投采用的是A股股票指数偏离偏离策略，适合以A股为主要投资范围的偏股型基金，所以智能定投收益率展示仅限于股票型 、混合型、指数型。'+dataObj.splitStr+dataObj.splitStr+'普通定投与智能定投计算公式相同。其中普通定投C1=C2=Cn'+dataObj.splitStr+dataObj.splitStr+'模拟历史业绩不代表基金投资收益，且模拟数据未考虑手续费、通货膨胀等因素。投资者应认真阅读拟投资基金的法律文件，了解基金的风险收益特征，并充分了解基金定投和银行零存整取等储蓄方式的区别。基金定投是引导投资者进行长期投资、平均投资成本的一种简单易行的投资方式，但是基金定投并不能规避基金投资固有风险，不能保证投资者获得收益。国信证券为基金销售机构，对基金管理人的投资运作不承担任何责任。敬请注意投资风险。');
    });

    //跳转到定投计算器
    $(document).on('click','#godtjsq',function(e){
        Com.setLocalValue('zh_cacu_ofcode',fundInfo.data[0].ofcode);
        Com.setLocalValue('zh_cacu_ofname',fundInfo.data[0].secuabbr);
        Com.setLocalValue('zh_cacu_tacode',fundInfo.data[0].tacode);
        Com.newWebViewOpenPage('',{"pageUrl":Com.getOrigin()+'/asset/mfdt/pages/dt_caculate.html?ofcode='+fundInfo.data[0].ofcode,"weburl":Com.getOrigin()+'/asset/mfdt/pages/dt_caculate.html?ofcode='+fundInfo.data[0].ofcode});
    });

    //从定投信息跳转到费率详情
    $(document).on('click','#dtflgo',function(){
        var param=joinParamForOpenUrl();
        Com.newWebViewOpenPage('',{"pageUrl":Com.getOrigin()+'/asset/mfund/pages/fund_details_flxq.html'+param,"weburl":Com.getOrigin()+'/asset/mfund/pages/fund_details_flxq.html'+param});
    });

    //基金解读视频跳转
    $(document).on('click','#jjjdvideogo',function(){
        var liveid = dataObj.jjjdvideo.liveid;
        var url = '';

        if(typeof dataObj.jjjdvideo.type!='undefined' && dataObj.jjjdvideo.type=='1'){
            //1-基金直播
            url = Com.getOrigin()+'/asset/invest_college/dist/pages/live.html?id='+liveid;
        }
        else if(typeof dataObj.jjjdvideo.type!='undefined' && dataObj.jjjdvideo.type=='2'){
            //2-投资者教育
            url = Com.getOrigin()+'/asset/invest_college/dist/pages/video.html?id='+liveid+'&from=lesson&shareFlag=1';
        }else{
            //3-基金解读
            url = Com.getOrigin()+'/asset/invest_college/dist/pages/video.html?id='+liveid+'&from=lesson';
        }

        Com.newWebViewOpenPage('',{"pageUrl":url,"weburl":url});
        try
        {
            TalkingData.onEventWithLabel("理财",'理财产品详情页-基金详情-视频入口');
        } catch(err) {}
    });

    //587需求，非QDII重仓股跳转到行情
    $(document).on('click','.gostockinfo',function(){
        var transfundtype = $(this).attr('transfundtype');
        var stkcode = $(this).attr('stkcode');
        var stkname = $(this).attr('stkname');
        var market = $(this).attr('market');
        if(transfundtype!='QDII'){
            Com.gotoStockInfo(stkcode, stkname, market);
        }
    });


    //业绩走势、净值估算切换
    $(document).on('click','.oldchartsmenu',function(){
        var fdt = getGlobalFundData();
        var oftype=fdt.oftype;
        if($(this).hasClass('on')){
            return false;
        }
        var $obj = $('.oldchartsmenu');
        var oindex = $obj.index($(this));
        $obj.removeClass('on').eq(oindex).addClass('on');
        $('.oldcharts').addClass('overnone').eq(oindex).removeClass('overnone');

        if(oindex == 0){
            if(yjzscharts){
                yjzscharts.clear();
                yjzscharts.setOption(yjzsoptions,true);
            }
        }else{
            if(ssgzParam.priceCharts){
                ssgzParam.priceCharts.clear();
                ssgzParam.priceCharts.setOption(priceChartsoptions,true);
            }
            try
            {
                TalkingData.onEventWithLabel("基金净值估算",'基金详情页-净值估算Tab');
            } catch(err) {}
        }
    });

    /*实时估值计算提示*/
    $(document).on('click','#ssgzjstips',function(){
        Com.showScreenMask('基金净值估算','净值估算算法：选取全市场宽基、风格、行业等500多个指数，计算指数与基金走势的相关性 、筛选出相关性高的指数，并用回归算法估算基金中每个指数的权重占比；盘中根据指数的涨跌幅来预估基金净值的涨跌幅。'+dataObj.splitStr+dataObj.splitStr+'风险提示：净值估算数据可能与最终净值存在差异，数据仅供参考，不代表实际业绩；请以基金公司公布数据为准。');
    });

    Com.getCommonLoginData(function (data) {
        //系统当前版本
        dataObj.sysVer = data.sysVer;
    });

    /*返回刷新执行refreshFunc,返回刷新目前只用于点击开售提醒弹出注册登录之后回到详情页执行*/
    Com.gobackRefreshPage(true,refreshFunc);

    /*认购前的基金点击开售提醒*/
    $(document).on('click','.godingyue',function(){
        var that = $(this);
        var obj = fundInfo.data[0]||{};
        if(!dataObj.isremindBtnSatus){
            return;
        }
        dingyueHandle(obj.ofcode,obj.tacode);
    });


    /*选择不同的指数重新画图*/
    $(document).on('click','.index_cs_menu',function(){
        var that = $(this);
        dataObj.chooseindex = that.attr('profitname');
        dataObj.indexname = that.html();
        yjChartsAjax(dataObj.choosetime,true);
        $('#indexchsbox').css('display','none')
    });

    //点击取消(关闭定投浮层)
    $(document).on('click','#index_cancel',function(e){
        $('#indexchsbox').css('display','none');
    });

    //点击黑色浮层隐藏定投浮层
    $(document).on('tap','#index_panel',function(e){
        var el = $(e.target);
        var elClass = el.attr('class');
        if(elClass.indexOf('index_panel_box')!='-1'){
            $('#itc_panel').css('display','none');
        }
    });

    $(document).on('click','.line_yj_ft_590',function(){
        $('#indexchsbox').css('display','block');
    });

    //点击黑色浮层隐藏定投浮层
    $(document).on('tap','#indexlistchs',function(e){
        var el = $(e.target);
        var elClass = el.attr('class');
        if(elClass.indexOf('index_panel_box')!='-1'){
            $('#indexchsbox').css('display','none');
        }
    });

}

/**
 * 获取盘中估值曲线
 */
var ssgzParam={
    "priceCharts":null,
    "arrCurTime":[],
    "dtTimeAM":'',
    "dtTimePM":'',
    "line_data":[]
};
var priceChartsoptions = {
    title: {
        show:false,
        padding:0,
        text: '净值估算'
    },
    legend: {
        show:false,
        data:['净值估算']
    },
    animation:false,
    toolbox: {
        show:false,
        feature: {
            saveAsImage: {}
        }
    },
    grid: {
        left: '10px',
        right: '10px',
        bottom: '10px',
        top:'8px',
        containLabel: true
    },
    xAxis : [
        {
            type : 'category',
            boundaryGap : false,
            data : [],
            axisLabel:{
                textStyle:{
                    color:'#8e8e93',
                    fontSize:11,
                    align:'right'
                },
                interval:0,
                margin:15,
                formatter: function (value, index) {
                    return value;
                }
            },
            axisLine: {            // 坐标轴线
                lineStyle: {       // 属性lineStyle控制线条样式
                    color: '#f6f6f7'
                },
                show:false
            },
            axisTick: {            // 坐标刻度
                show:false
            },
            splitLine: {           // 分隔线
                interval:300,
                show:true,
                lineStyle: {       // 属性lineStyle（详见lineStyle）控制线条样式
                    color: ['#f6f6f7']
                }
            }
        }
    ],
    yAxis : [
        {
            type : 'value',
            splitLine: {           // 分隔线
                lineStyle: {       // 属性lineStyle（详见lineStyle）控制线条样式
                    color: ['#f6f6f7'],
                    type:'dashed'  //'solid'  'dashed'  'dotted'
                }
            },
            axisLine: {            // 坐标轴线
                show:false,
                lineStyle: {       // 属性lineStyle控制线条样式
                    color: '#f6f6f7'
                }
            },
            axisLabel:{
                // inside:true,
                textStyle:{
                    color:'#8e8e93',
                    baseline:'middle',
                    fontSize:11
                },
                formatter: function (value, index) {
                    return (value*1).toFixed(2)+'%';
                }
            },
            axisTick:{
                show:false
            },
            splitNumber:4
        }
    ],
    series : [
        {
            name:'本基金累计收益',
            type:'line',
            data:[],
            areaStyle: {
                normal: {
                    color:'transparent'
                },
                smooth:true
            },
            lineStyle:{
                normal:{
                    width:1,
                    color:'#589dfc'
                }
            },
            animation:false,
            itemStyle:{
                normal : {
                    color:'#589dfc',
                    lineStyle:{
                        color:'#589dfc'
                    }
                }
            },
            showSymbol :true,
            symbolSize:0
        }
    ]
};

function addZero(val, len, top)
{
    if (!arguments[1]) len = 2;
    if (!arguments[2]) top = true;

    if (val.toString().length < len)
    {
        while (len != val.toString().length)
        {
            if (top) val = "0" + val.toString();
            else val = val.toString() + "0";
        }
    }
    return val.toString();
}
function getCurDate()
{
    return [new Date().getFullYear(), addZero(new Date().getMonth()+1), addZero(new Date().getDate())].join("");
}


/*获取实时估值图表*/
function getPriceOnTime(ofcode){
    var initData = function(){
        var dtCurDate = new Date();
        /*时间从当前交易日9点30开始，X轴的日期是以分钟为单位，从9点半到11点半，13:00到15:00是4个小时，所以X轴一共是240个刻度*/

        /*9:30到11:30的120个X轴刻度*/
        ssgzParam.dtTimeAM = new Date(dtCurDate.getFullYear(), dtCurDate.getMonth(), dtCurDate.getDate(), 9, 30, 0, 0);
        for (var i=0; i<=120; i++)
        {
            ssgzParam.arrCurTime.push([addZero(ssgzParam.dtTimeAM.getHours()), addZero(ssgzParam.dtTimeAM.getMinutes())].join(":"));
            ssgzParam.dtTimeAM = new Date(ssgzParam.dtTimeAM.getTime() + 60*1000);
        }

        /*13:01到15:00的119个X轴刻度(因为给过来的数据没有13:00这个点的数据，所有要把这个时间排除)*/
        ssgzParam.dtTimePM = new Date(dtCurDate.getFullYear(), dtCurDate.getMonth(), dtCurDate.getDate(), 13, 1, 0, 0);
        for (var j=0; j<=119; j++)
        {
            ssgzParam.arrCurTime.push([addZero(ssgzParam.dtTimePM.getHours()), addZero(ssgzParam.dtTimePM.getMinutes())].join(":"));
            ssgzParam.dtTimePM = new Date(ssgzParam.dtTimePM.getTime() + 60*1000);
        }
        /*先将初始估值都设置成'-'，从接口取到实时数据后，将估值替换成接口的真实估值*/
        for (var m=0; m<ssgzParam.arrCurTime.length; m++)
        {
            ssgzParam.line_data.push( {name: ssgzParam.arrCurTime[m], value: "-"} );
        }
        priceChartsoptions.xAxis[0].data=ssgzParam.arrCurTime;
        priceChartsoptions.series[0].data=ssgzParam.line_data;
    };
    initData();


    var param = {};
    param['ofcode'] = ofcode;
    priceChartsoptions.xAxis[0].data=[];
    Com.ajax({
        "url":Com.getOrigin()+"/gsfinancing/fundinfo/getrtvaluationlist/1.0",
        "data":param,
        "type":"post",
        "dataType":"json",
        "success":function(d){
            var nodatafunc=function(){
                var nodata=$('<div class="nochartsData"><img src="../../common/images/no_data.png" width="120"><div>暂无估值数据</div></div>');
                $('#ssgznodate').html(nodata);
                $('#ssgzchartsbox').addClass('overnone');
            };
            var isLocalTradetime = getLocalTradetime();
            if(d.result[0].code == '0'){
                if(typeof d.data !== 'undefined' && d.data.length != 0){
                    d.data = d.data.reverse();
                    $('#ssgznodate').html('');
                    $('#ssgzchartsbox').removeClass('overnone');
                    /*画图表*/
                    var tempdot='';
                    for(var i=0;i< d.data.length;i++){
                        /*遍历一下接口给的数据和priceChartsoptions.series[0].data，对比一下时间，如果时间相同，把priceChartsoptions.series[0].data[m].value改成真实的估值，这里也做到了将给过来的数据不是从：09:30分开始的都排除掉*/
                        for(var m=0;m<priceChartsoptions.series[0].data.length;m++){
                            tempdot = (priceChartsoptions.series[0].data[m].name).replace(/:/g,'');
                            if(tempdot==d.data[i].updatetime){
                                priceChartsoptions.series[0].data[m].value=(d.data[i].rtincrease*1);
                            }
                            if(i==d.data.length-1&&tempdot==d.data[i].updatetime){
                                if(isLocalTradetime){
                                    priceChartsoptions.series[0].data[m].symbol='circle';
                                    priceChartsoptions.series[0].data[m].symbolSize=6;
                                }


                            }
                        }

                    }
                    for(var j = 0;j<ssgzParam.arrCurTime.length;j++){
                        if(j==0){
                            priceChartsoptions.xAxis[0].data[j] = {
                                value:ssgzParam.arrCurTime[j],
                                textStyle:{
                                    color:'#8e8e93',
                                    fontSize:11,
                                    align:'left'
                                }
                            };
                        }
                        else if(j== ssgzParam.arrCurTime.length-1){
                            priceChartsoptions.xAxis[0].data[j] = {
                                value:ssgzParam.arrCurTime[j],
                                textStyle:{
                                    color:'#8e8e93',
                                    fontSize:11,
                                    align:'right'
                                }
                            };
                        }
                        else if(ssgzParam.arrCurTime[j]=='11:30'){
                            priceChartsoptions.xAxis[0].data[j] = {
                                value:'11:30/13:00',
                                textStyle:{
                                    color:'#8e8e93',
                                    fontSize:11,
                                    align:'center'
                                }
                            };
                        }
                        else{
                            priceChartsoptions.xAxis[0].data[j]='';
                        }
                    }
                    //priceChartsoptions.xAxis[0].splitLine.interval = Math.floor(d.data.length-1);
                    ssgzParam.priceCharts = echarts.init(document.getElementById('canvasssgz'));
                    ssgzParam.priceCharts.clear();
                    ssgzParam.priceCharts.setOption(priceChartsoptions,true);
                    var datalastindex = d.data.length-1;
                    var htmldataobj={"estnav":d.data[datalastindex].estnav,"tradingdate":d.data[datalastindex].tradingdate,"updatetime":d.data[datalastindex].updatetime,"rtincrease":d.data[datalastindex].rtincrease};

                    var ssgzhtmldata = $(template('ssgzbottomdata', htmldataobj));//头部数据
                    $('#ssgzhtml').html(ssgzhtmldata);

                }else{
                    //图表暂无数据
                    nodatafunc();
                    return false;
                }
            }else{
                //图表暂无数据
                nodatafunc();
            }

        },
        "isTradeLogin":false,
        "error":function(){
            Com.ajaxLoaded();
            blackTipBlock('网络不给力getrtvaluationlist',2000)
        }
    });
}


//跳转地址需要的参数
function joinParamForOpenUrl(){
    var obj = fundInfo.data[0];
    var ofcode = obj.ofcode;
    var tacode = obj.tacode;
    var secuid = obj.secuid;
    var ofstatus = obj.ofstatus;
    var oftype = obj.orioftype;
    var companyid = obj.investadvisorcode;
    var personalids='';
    for(var i = 0;i<fundInfo.data2.length;i++){
        if(personalids==''){
            personalids = fundInfo.data2[i].personalid;
        }else{
            personalids+=','+fundInfo.data2[i].personalid;
        }
    }
    return '?ofcode='+ofcode+'&tacode='+tacode+'&secuid='+secuid+'&ofstatus='+ofstatus+'&oftype='+oftype+'&companyid='+companyid+'&personalids='+personalids+'&chooseindex='+dataObj.chooseindex;
}




/*****************************************************************************/
//基金公司业绩柱状图
var bar_option = {
    animation:false,
    title: {
        show:false,
        padding:0,
        text: '历史收益率'
    },
    grid: {
        left: '0',
        right: '0',
        bottom: '30px',
        top:'20px',
        containLabel: false
        //show:false
    },
    xAxis : [
        {
            type : 'category',

            //data : ['货币类','债券','权益','全球'],
            data : ['近1年','近3年','近5年'],
            axisLabel:{
                textStyle:{
                    color:'#8e8e93',
                    fontSize:11,
                    align:'center'
                },
                interval:0,
                margin:15,
                formatter: function (value, index) {
                    return value;
                }
            },
            axisLine: {            // 坐标轴线
                lineStyle: {       // 属性lineStyle控制线条样式
                    color: '#fff'
                },
                show:true
            },
            axisTick: {            // 坐标刻度
                show:false
            },
            splitLine: {           // 分隔线
                interval:30,
                show:false,
                lineStyle: {       // 属性lineStyle（详见lineStyle）控制线条样式
                    color: ['#f6f6f7']
                }
            }
        }
    ],
    yAxis : [
        {
            type : 'value',
            //show:false,
            /*min:0,
            max:100,
            interval:20,*/
            splitLine: {
                lineStyle: {       // 属性lineStyle（详见lineStyle）控制线条样式
                    color: ['#fff'],
                    type:'dashed'  //'solid'  'dashed'  'dotted'
                }
            },

            axisLine: {            // 坐标轴线
                show:false,
                lineStyle: {       // 属性lineStyle控制线条样式
                    color: '#fff'
                }
            },
            axisLabel:{
                show:false,
                // inside:true,
                textStyle:{
                    color:'#8e8e93',
                    baseline:'middle',
                    fontSize:11
                },
                formatter: function (value, index) {
                    return value+'%';
                }
            },
            axisTick:{
                show:false
            }
        }
    ],
    color: ['#FF8F66','#FFC979','#A3C9FF','#92E09C'],
    series : [
        {
            name:'优秀',
            type:'bar',
            itemStyle:{normal:{label:{color:'#939aaa',show: true, position:'top'},barBorderRadius:[3, 3, 0, 0]}},
            data:[-40, 30, 62]
        },
        {
            name:'良好',
            type:'bar',
            itemStyle:{normal:{label:{color:'#939aaa',show: true, position:'top'},barBorderRadius:[3, 3, 0, 0]}},
            data:[30, -72, 12]
        },
        {
            name:'一般',
            type:'bar',
            itemStyle:{normal:{label:{color:'#939aaa',show: true, position:'top'},barBorderRadius:[3, 3, 0, 0]}},
            data:[30, 72, -12]
        },
        {
            name:'较差',
            type:'bar',
            itemStyle:{normal:{label:{color:'#939aaa',show: true, position:'top'},barBorderRadius:[3, 3, 0, 0]}},
            data:[30, 72, 12]
        }
    ]
};

var bar_option_2 = {
    animation:false,
    title: {
        show:false,
        padding:0,
        text: '历史收益率'
    },
    grid: {
        left: '0',
        right: '0',
        bottom: '30px',
        top:'20px',
        containLabel: false
        //show:false
    },
    xAxis : [
        {
            type : 'category',

            //data : ['货币类','债券','权益','全球'],
            data : ['近1年','近3年','近5年'],
            axisLabel:{
                textStyle:{
                    color:'#8e8e93',
                    fontSize:11,
                    align:'center'
                },
                interval:0,
                margin:15,
                formatter: function (value, index) {
                    return value;
                }
            },
            axisLine: {            // 坐标轴线
                lineStyle: {       // 属性lineStyle控制线条样式
                    color: '#fff'
                },
                show:true
            },
            axisTick: {            // 坐标刻度
                show:false
            },
            splitLine: {           // 分隔线
                interval:30,
                show:false,
                lineStyle: {       // 属性lineStyle（详见lineStyle）控制线条样式
                    color: ['#f6f6f7']
                }
            }
        }
    ],
    yAxis : [
        {
            type : 'value',
            //show:false,
            /*min:0,
             max:100,
             interval:20,*/
            splitLine: {
                lineStyle: {       // 属性lineStyle（详见lineStyle）控制线条样式
                    color: ['#fff'],
                    type:'dashed'  //'solid'  'dashed'  'dotted'
                }
            },

            axisLine: {            // 坐标轴线
                show:false,
                lineStyle: {       // 属性lineStyle控制线条样式
                    color: '#fff'
                }
            },
            axisLabel:{
                show:false,
                // inside:true,
                textStyle:{
                    color:'#8e8e93',
                    baseline:'middle',
                    fontSize:11
                },
                formatter: function (value, index) {
                    return value+'%';
                }
            },
            axisTick:{
                show:false
            }
        }
    ],
    color: ['#FF8F66','#FFC979','#A3C9FF','#92E09C'],
    series : [
        {
            name:'优秀',
            type:'bar',
            itemStyle:{normal:{label:{color:'#939aaa',show: true, position:'top'},barBorderRadius:[3, 3, 0, 0]}},
            data:[-40, 30, 62]
        },
        {
            name:'良好',
            type:'bar',
            itemStyle:{normal:{label:{color:'#939aaa',show: true, position:'top'},barBorderRadius:[3, 3, 0, 0]}},
            data:[30, -72, 12]
        },
        {
            name:'一般',
            type:'bar',
            itemStyle:{normal:{label:{color:'#939aaa',show: true, position:'top'},barBorderRadius:[3, 3, 0, 0]}},
            data:[30, 72, -12]
        },
        {
            name:'较差',
            type:'bar',
            itemStyle:{normal:{label:{color:'#939aaa',show: true, position:'top'},barBorderRadius:[3, 3, 0, 0]}},
            data:[30, 72, 12]
        }
    ]
};


/**基金资产规模柱状图***/
var jjgm_option = {
    animation:false,
    title: {
        show:false,
        text: '基金资产规模'
    },
    grid: {
        left: '0',
        right: '0',
        bottom: '30px',
        top:'50px',
        containLabel: false
        //show:false
    },
    xAxis : [
        {
            type : 'category',

            //data : ['货币类','债券','权益','全球'],
            data : ['2017-09-30','2017-12-31','2018-03-31','2018-06-30'],
            axisLabel:{
                textStyle:{
                    color:'#8e8e93',
                    fontSize:11,
                    align:'center'
                },
                interval:0,
                margin:15,
                formatter: function (value, index) {
                    return value;
                }
            },
            axisLine: {            // 坐标轴线
                lineStyle: {       // 属性lineStyle控制线条样式
                    color: '#fff'
                },
                show:true
            },
            axisTick: {            // 坐标刻度
                show:false
            },
            splitLine: {           // 分隔线
                interval:30,
                show:false,
                lineStyle: {       // 属性lineStyle（详见lineStyle）控制线条样式
                    color: ['#f6f6f7']
                }
            }
        }
    ],
    yAxis : [
        {
            type : 'value',
            //show:false,
            interval:20,
            splitLine: {
                lineStyle: {       // 属性lineStyle（详见lineStyle）控制线条样式
                    color: ['#fff'],
                    type:'dashed'  //'solid'  'dashed'  'dotted'
                }
            },

            axisLine: {            // 坐标轴线
                show:false,
                lineStyle: {       // 属性lineStyle控制线条样式
                    color: '#fff'
                }
            },
            axisLabel:{
                show:false,
                // inside:true,
                textStyle:{
                    color:'#8e8e93',
                    baseline:'middle',
                    fontSize:11
                },
                formatter: function (value, index) {
                    return value+'%';
                }
            },
            axisTick:{
                show:false
            }
        }
    ],
    color: ['#589dfc'],
    series : [
        /*{
            name:'优秀',
            type:'bar',
            itemStyle:{normal:{label:{color:'#939aaa',show: true, position:'top'}}},
            data:[40, 30, 62]
        },
        {
            name:'良好',
            type:'bar',
            itemStyle:{normal:{label:{color:'#939aaa',show: true, position:'top'}}},
            data:[30, 72, 12]
        },
        {
            name:'一般',
            type:'bar',
            itemStyle:{normal:{label:{color:'#939aaa',show: true, position:'top'}}},
            data:[30, 72, 12]
        },*/
        {
            barWidth : 35,
            name:'较差',
            type:'bar',
            itemStyle:{normal:{label:{color:'#939aaa',show: true, position:'top'},barBorderRadius:[3, 3, 0, 0]}},
            data:[20,40,50,60]
        }
    ]
};

/**基金资产规模柱状图***/
var jjfe_option = {
    animation:false,
    title: {
        show:false,
        text: '基金份额规模'
    },
    grid: {
        left: '0',
        right: '0',
        bottom: '30px',
        top:'50px',
        containLabel: false
        //show:false
    },
    xAxis : [
        {
            type : 'category',

            //data : ['货币类','债券','权益','全球'],
            data : ['2017-09-30','2017-12-31','2018-03-31','2018-06-30'],
            axisLabel:{
                textStyle:{
                    color:'#8e8e93',
                    fontSize:11,
                    align:'center'
                },
                interval:0,
                margin:15,
                formatter: function (value, index) {
                    return value;
                }
            },
            axisLine: {            // 坐标轴线
                lineStyle: {       // 属性lineStyle控制线条样式
                    color: '#fff'
                },
                show:true
            },
            axisTick: {            // 坐标刻度
                show:false
            },
            splitLine: {           // 分隔线
                interval:30,
                show:false,
                lineStyle: {       // 属性lineStyle（详见lineStyle）控制线条样式
                    color: ['#f6f6f7']
                }
            }
        }
    ],
    yAxis : [
        {
            type : 'value',
            //show:false,
            interval:20,
            splitLine: {
                lineStyle: {       // 属性lineStyle（详见lineStyle）控制线条样式
                    color: ['#fff'],
                    type:'dashed'  //'solid'  'dashed'  'dotted'
                }
            },

            axisLine: {            // 坐标轴线
                show:false,
                lineStyle: {       // 属性lineStyle控制线条样式
                    color: '#fff'
                }
            },
            axisLabel:{
                show:false,
                // inside:true,
                textStyle:{
                    color:'#8e8e93',
                    baseline:'middle',
                    fontSize:11
                },
                formatter: function (value, index) {
                    return value+'%';
                }
            },
            axisTick:{
                show:false
            }
        }
    ],
    color: ['#589dfc'],
    series : [
        /*{
         name:'优秀',
         type:'bar',
         itemStyle:{normal:{label:{color:'#939aaa',show: true, position:'top'}}},
         data:[40, 30, 62]
         },
         {
         name:'良好',
         type:'bar',
         itemStyle:{normal:{label:{color:'#939aaa',show: true, position:'top'}}},
         data:[30, 72, 12]
         },
         {
         name:'一般',
         type:'bar',
         itemStyle:{normal:{label:{color:'#939aaa',show: true, position:'top'}}},
         data:[30, 72, 12]
         },*/
        {
            barWidth : 35,
            name:'较差',
            type:'bar',
            itemStyle:{normal:{label:{color:'#939aaa',show: true, position:'top'},barBorderRadius:[3, 3, 0, 0]}},
            data:[20,40,50,60]
        }
    ]
};


/**雷达图***/
var radarOption = {
    title: {
        show:false,
        text: '基础雷达图'
    },
    tooltip: {
        show:false,
    },
    grid: {
        left: '50px',
    },
    legend: {
        show:false,
    },
    radar: {
        shape: 'circle',
        name: {
            show:false,
        },
        splitLine: {
            show: false
        },
        splitArea: {
            show: false
        },
        axisLine: {
            show: false
        },
        indicator: [
            { name: '任期回报', max: 100},
            { name: '任职最大回撤控制', max: 100},
            { name: '管理基金经验', max: 100},
            { name: '历任基金回报排名', max: 100},
            { name: '任职业绩稳定性', max: 100},
        ]
    },
    series: [{
        name: '预算 vs 开销（Budget vs spending）',
        type: 'radar',
        itemStyle: {
            normal: {
                color: {
                    type: 'linear',
                    x: 0,y: 0,x2: 0,y2: 1,
                    colorStops: [{
                        offset: 0, color: 'rgba(118,179,255,0.80)' // 0% 处的颜色
                    },
                        {
                            offset:.5,color: 'rgba(118,179,255,0.80)' // 50% 处的颜色
                        },
                        {
                            offset: 1, color: 'rgba(118,179,255,0.80)' // 100% 处的颜色
                        }],
                    globalCoord: false // 缺省为 false
                }
            }
        },
        // symbol: 'image://' + resourcePath + '/images/jjsm/rpoint.png',
        symbolSize : [5, 5],
        areaStyle: {
            normal: {
                opacity: 1
            }
        },
        data : [
            {
                value : [],
                name : '基金经理'
            },
        ]
    }]
};
var F = F||{}; //定义一个全局对象作为命名空间
F.fundScan = F.fundScan||{};
F.fundScan.showFundManagerinfo = function(respone){
    //基金经理指数雷达图
    //var html3 = template('radarTemplate',respone.radarInfo[0]);
    var bg = $('.radar .bg');
    //$('.radar .chart-container').html(html3);
    $('.chart-container').height(bg.height());
    $('#radarBar').height(bg.height());
    //template.helpers.DC(respone.last5YearsIncomeInfo[i].tradingdate,'yyyy-MM-dd');
    if(typeof respone.radarInfo!='undefined'){
        radarOption.series[0].data[0].value = [template.helpers.DC(respone.radarInfo[0].avgHisProfitRank,5),template.helpers.DC(respone.radarInfo[0].profitRank,5),template.helpers.DC(respone.radarInfo[0].retraceRank,5),template.helpers.DC(respone.radarInfo[0].profitWinSelect,8),template.helpers.DC(respone.radarInfo[0].mgrExpRank,5)];
        var radarBar = echarts.init(document.getElementById('radarBar'));
        radarBar.setOption(radarOption);
    }

}

/**
 * 数据检查和处理dataCheck,简称DC
 * @data 需要处理的数据，字符串类型
 * @action 对数据进行处理的方式
 * 1、是否为空，为空返回"--"
 * 2、是否为空，为空返回"--",不为空(data*100).toFixed2(2)
 * 3、是否为空，为空返回"--",不为空(data*1).toFixed2(2)
 * 4、是涨还是跌，涨返回red，跌返回green，否则返回空
 * 5、用于处理雷达图的数据，如果是不存在或者为空，返回0，否则返回(1-data)*100
 * 6、是否为空，为空返回"--",不为空(1-data)*100.toFixed(0)
 * 7、是否为空，为空返回"--",不为空data*100.toFixed(0)
 * 8、是否为空，为空返回0,不为空data*100
 * 返回结果
 */
template.helper('DC', function (data,action) {
    if (action == 1) {
        if (data==undefined||data==="") {
            return '--';
        }else{
            return data;
        }
    }else if (action == 2) {
        if (data==undefined||data==="") {
            return '--';
        }else{
            return (data*100).toFixed2(2);
        }
    }else if (action == 3) {
        if (data==undefined||data==="") {
            return '--';
        }else{
            return (data*1).toFixed2(2);
        }
    }else if (action == 4) {
        if (data==undefined||data===""||data==0) {
            return '';
        }else{
            data = data.toString();
            if(data.indexOf('-') > -1){
                return 'green';
            }else{
                return 'red';
            }
        }
    }else if (action == 5) {
        if (data==undefined||data==="") {
            return 0;
        }else{
            return (1-data)*100;
        }
    }else if (action == 6) {
        if (data==undefined||data==="") {
            return '--';
        }else{
            return ((1-data)*100).toFixed(0);
        }
    }else if (action == 7) {
        if (data==undefined||data==="") {
            return '--';
        }else{
            return (data*100).toFixed(0);
        }
    }else if (action == 8) {
        if (data==undefined||data==="") {
            return 0;
        }else{
            return data*100;
        }
    }

});

/*投资人结果饼图*/
var pie_options = {
    color:['#F3796F', '#FFCF79','#EFC028','#F2572D','#AC2DF2'],
    animation:false,
    series: [
        {
            name:'访问来源',
            type:'pie',
            radius: ['50%', '80%'],
            avoidLabelOverlap: false,
            hoverAnimation:false,
            label: {
                normal: {
                    show: false,
                    position: 'center'
                },
                emphasis: {
                    show: false,
                    textStyle: {
                        fontSize: '12',
                        fontWeight: 'bold'
                    }
                }
            },
            labelLine: {
                normal: {
                    show: false
                }
            },
            data:[
                {value:335, name:'直接访问'},
                {value:310, name:'邮件营销'},
                {value:234, name:'联盟广告'},
                {value:135, name:'视频广告'},
                {value:1548, name:'搜索引擎'}
            ]
        }
    ]
};


/***************风险控制*****************/
var lineChartOption = {
    title: {
        show:false,
        text: '风险控制'
    },
    legend: {
        show:false
    },
    grid: {
        left: '2px',
        right: '5px',
        bottom: '10px',
        top:'8px',
        containLabel: true
    },
    xAxis:  {
        type: 'category',
        boundaryGap: false,
        data : [{
            value:'2017-07-24',
            textStyle:{
                color:'#8e8e93',
                fontSize:11,
                align:'left',
            },
        },'','','2017-07-25','','','2017-07-26'],
        axisLine: {            // 坐标轴线
            lineStyle: {       // 属性lineStyle控制线条样式
                color: '#f6f6f7'
            },
            show:true,
        },
        axisTick: {            // 坐标刻度
            show:false,
        },
        splitLine: {
            show: false
        },
        axisLabel:{
            show:true,
            textStyle:{
                color:'#8e8e93',
                fontSize:11,
                align:'right',
            },
            interval:0,
            margin:15,
            // formatter: function (value,index) {
            //     if (index == 0||index == 0) {
            //         return value;
            //     }else{
            //         return '';
            //     }

            // }
        },
    },
    yAxis: {
        type : 'value',
        splitLine: {           // 分隔线
            lineStyle: {       // 属性lineStyle（详见lineStyle）控制线条样式
                color: ['#f6f6f7'],
                type:'solid'  //'solid'  'dashed'  'dotted'
            }
        },
        axisLine: {            // 坐标轴线
            show:false,
            lineStyle: {       // 属性lineStyle控制线条样式
                color: '#f6f6f7'
            }
        },
        axisLabel:{
            // inside:true,
            textStyle:{
                color:'#8e8e93',
                baseline:'middle',
                fontSize:11,
            },
            formatter: function (value, index) {
                return value+'%';
            }
        },
        axisTick:{
            show:false,
        },
        splitNumber:4
    },
    visualMap: {
        show: false,
        dimension: 0,
        pieces: [{
            lt: '',
            color: 'red'
        }, {
            gte: '',
            lte:'',
            color: 'green'
        }, {
            gt: '',
            color: 'red'
        }]
    },
    series : [
        {
            name:'本基金',
            type:'line',
            // stack: '总量',
            data:[5.2,3.1,2.1,4.5,7.8,4.5,6.9],
            areaStyle: {
                normal: {
                    color:'transparent',
                },
                smooth:true
            },

            lineStyle:{
                normal:{
                    width:1,
                    color:'#589DFC'
                }
            },
            itemStyle:{
                normal : {
                    // color:'#589DFC',
                    lineStyle:{
                        // color:'#589DFC'
                    }
                }
            },
            showSymbol :false,
        },
        {
            name:'中证800',
            type:'line',
            // stack: '总量',
            data:[5.1,3.1,2.5,4.5,7.4,4.5,6.9],
            areaStyle: {
                normal: {
                    color:'transparent',
                },
                smooth:true
            },
            lineStyle:{
                normal:{
                    width:1,
                    color:'#F1C877'
                }
            },
            itemStyle:{
                normal : {
                    color:'#D0D9EC',
                    lineStyle:{
                        color:'#D0D9EC'
                    }
                }
            },
            showSymbol :false
        },
        {
            name:'最大回撤',
            type:'line',
            // stack: '总量',
            data:[5.1,3.1,2.5,4.5,7.4,4.5,6.9],
            areaStyle: {
                normal: {
                    color:'rgba(88,157,252,0.2)',
                },
                smooth:true
            },
            lineStyle:{
                normal:{
                    width:1,
                    color:'#589DFC'
                }
            },
            itemStyle:{
                normal : {
                    color:'#589DFC',
                    lineStyle:{
                        color:'#589DFC'
                    }
                }
            },
            showSymbol :false
        }
    ]
}

/********************************************************/
/*指数型基金标的对比柱状图*/
var compareindex = {
    grid: {
        top: 30,
        bottom: 30,
        left: '0',
        right: '0',
        containLabel: false
    },
    xAxis: {

        axisLabel:{
            textStyle:{
                color:'#8e8e93',
                fontSize:11,
                align:'center'
            },
            interval:0,
            margin:15,
            formatter: function (value, index) {
                return value;
            }
        },
        axisLine: {            // 坐标轴线
            lineStyle: {       // 属性lineStyle控制线条样式
                color: '#fff'
            },
            show:true
        },
        axisTick: {            // 坐标刻度
            show:false
        },
        splitLine: {           // 分隔线
            interval:30,
            show:false,
            lineStyle: {       // 属性lineStyle（详见lineStyle）控制线条样式
                color: ['#f6f6f7']
            }
        },

        type : 'category',
        data : ['近1周', '近1月', '近3月']


    },
    yAxis : [
        {
            type : 'value',
            splitLine: {
                lineStyle: {       // 属性lineStyle（详见lineStyle）控制线条样式
                    color: ['#fff'],
                    type:'dashed'  //'solid'  'dashed'  'dotted'
                }
            },

            axisLine: {            // 坐标轴线
                show:false,
                lineStyle: {       // 属性lineStyle控制线条样式
                    color: '#fff'
                }
            },
            axisLabel:{
                show:false,
                // inside:true,
                textStyle:{
                    color:'#8e8e93',
                    baseline:'middle',
                    fontSize:11
                },
                formatter: function (value, index) {
                    return value+'%';
                }
            },
            axisTick:{
                show:false
            }
        }
    ],
    color: ['#FD9C68','#A3C9FF'],
    series : [

        {
            barWidth : 35,
            name:'中证500',
            type:'bar',
            itemStyle:{
                normal:{
                    label: {
                        color:'#939aaa',
                        show: true,
                        position:'top',
                        barBorderRadius:[3, 3, 0, 0],
                        formatter: function (value, index) {
                            return (value.value*1).toFixed(2)+'%';
                        }
                    }

                }
            },
            data:[-40, 30, 62]
        },
        {
            barWidth : 35,
            name:'沪深300',
            type:'bar',
            itemStyle:{
                normal:{
                    label: {
                        color:'#939aaa',
                        show: true,
                        position:'top',
                        barBorderRadius:[3, 3, 0, 0],
                        formatter: function (value, index) {
                            return (value.value*1).toFixed(2)+'%';
                        }
                    }

                }
            },
            data:[30, 72, 12]
        }
    ]
};

/********************************************************/

//新基金获取基金经理信息+基金经理当前管理的基金
var manageindex = 0;
function getManageInfo(personalids){
    var param = {};
    param['personalids'] = personalids;
    Com.ajax({
        "url":Com.getOrigin()+"/gsfinancing/ixcfundsearch/getfundmanagers/1.0",
        "data":param,
        "type":"post",
        "dataType":"json",
        "success":function(d){
            Com.ajaxLoaded();
            if(d.result[0].code == '0'){
                if(d.data1.length!=0 && d.data1[0]!=null){
                    for(var i=0;i<d.data1.length;i++){
                        for(var j=0;j<d.data2.length;j++){
                            if(d.data1[i].personalid == d.data2[j].personalid && d.data2[j].dimissdate==''){
                                if(typeof d['fund_'+d.data1[i].personalid] == 'undefined'){
                                    d['fund_'+d.data1[i].personalid]=[];
                                }
                                if(d['fund_'+d.data1[i].personalid].length<3){
                                    d['fund_'+d.data1[i].personalid].push(d.data2[j]);
                                }

                            }
                        }
                        console.log(d['fund_'+d.data1[i].personalid])
                        d.data1[i].funds = d['fund_'+d.data1[i].personalid];
                    }

                    var oHtml1 = $(template('ztnr_manages_info', d));
                    $('#managewrapper').html(oHtml1);
                    /*基金经理滑动*/
                    if(d.data1.length>1){
                        var swiper = new Swiper('.swiper-container', {
                            pagination: '.sod',
                            animation:false,
                            //slidesPerView: 'auto',
                            // paginationClickable: true,
                            //spaceBetween: 0,
                            freeMode:false,
                            onSlideChangeEnd:function(swiper){
                                manageindex = swiper.activeIndex;
                                //alert(manageindex)
                                var psid = $('.swiper-slide').eq(manageindex).attr('personalid');
                                $('.manages_funds_box').addClass('displaynone')
                                $('#manages_funds_'+psid).removeClass('displaynone');
                                /* var activeWrapper = $('#wrapper_'+groupArry[groupIndex]);
                                 if(!activeWrapper.hasClass('loaded')){
                                 //当前tab没加载过就加载
                                 getGroupDetails(groupArry[groupIndex]);
                                 }else{
                                 //当前tab已加载过，不需要发请求了，显示当前tabtie就行
                                 Com.setWebviewTitle('',{"title":groupTitleArry[groupIndex] ,"bgColor":"272736"});
                                 }*/
                            }
                        });
                    }

                }

            }
            else if(d.result[0].code == '11' || d.result[0].code == '18' || d.result[0].code == '19'){
                return false;
            }
            else{
                Com.showNativeAlert("",d.result[0].msg,["确定"],'');
            }
        },
        "isTradeLogin":false,
        "error":function(){
            Com.ajaxLoaded();
            blackTipBlock('网络不给力|getixcfundmanagerbasicinfo',2000)
        }
    });
}


//新基金获取基金公司信息
function getfundCompanyInfo(companyId){
    var param = {};
    param['companyId'] = companyId;
    Com.ajax({
        "url":Com.getOrigin()+"/gsfinancing/jjsm/gejjxqcompany/1.0",
        "data":param,
        "type":"post",
        "dataType":"json",
        "success":function(d){
            if(d.result[0].code == '0'){
                if(typeof fundInfo!='undefined' && fundInfo.data.length!=0){
                    if(fundInfo.data[0].isindex=='1'){
                        //优先判断是不是指数型
                        fundInfo.data[0].oftype='8';
                    }
                }
                d.oftype= fundInfo.data[0].oftype;
                d.secuabbr= fundInfo.data[0].secuabbr;
                d.ofcode= fundInfo.data[0].ofcode;
                var oHtml1 = $(template('companySortDemo', d));
                $('#fdp_sortinfo').html(oHtml1);

                $('#typeyjtxtx').html(oftypechn(fundInfo.data[0].oftype)+'基金管理业绩');

                /*基金管理业绩柱状图*/
                var pf=[];//优秀
                var gd=[];//良好
                var nm=[];//一般
                var bd=[];//较差
                $('#barCharts').width($(window).width());
                for(var i = 0;i< d.data.length;i++){
                    if(d.data[i].oftype ==fundInfo.data[0].oftype ){
                        pf=[d.data[i].pct_1year_1_4,d.data[i].pct_3year_1_4,d.data[i].pct_5year_1_4];
                        gd=[d.data[i].pct_1year_2_4,d.data[i].pct_3year_2_4,d.data[i].pct_5year_2_4];
                        nm=[d.data[i].pct_1year_3_4,d.data[i].pct_3year_3_4,d.data[i].pct_5year_3_4];
                        bd=[d.data[i].pct_1year_4_4,d.data[i].pct_3year_4_4,d.data[i].pct_5year_4_4];
                    }
                }
                bar_option.series[0].data = pf;
                bar_option.series[1].data = gd;
                bar_option.series[2].data = nm;
                bar_option.series[3].data = bd;
                var zcpzChart = echarts.init(document.getElementById('barCharts'));
                zcpzChart.setOption(bar_option);
            }
            else if(d.result[0].code == '11' || d.result[0].code == '18' || d.result[0].code == '19'){
                return false;
            }
            else{
                Com.showNativeAlert("",d.result[0].msg,["确定"],'');
            }
        },
        "isTradeLogin":false,
        "error":function(){
            Com.ajaxLoaded();
            blackTipBlock('网络不给力|gejjxqcompany',2000)
        }
    });
}



/**
 *老基金-货币基金-基金规模
 * @param secuid
 * @param usetype 货币型基金用"hbtype    非货币基金查概况规模normaltype
 */
function fundguimo(secuid,usetype){
    var param = {};
    param['secuid'] = secuid;
    Com.ajax({
        "url":Com.getOrigin()+"/gsfinancing/fundinfo/getfundscale/1.0",
        "data":param,
        "type":"post",
        "dataType":"json",
        "success":function(d){
            if(d.result[0].code == '0'){
                if(usetype =='hbtype'){
                    jjgm_option.xAxis[0].data = [];
                    jjgm_option.series[0].data = [];
                    if(typeof d.data1!='undefined' && d.data1.length!=0){
                        d.data1.reverse();
                        for(var i=0;i< d.data1.length;i++){
                            jjgm_option.xAxis[0].data.push(d.data1[i].enddate);
                            jjgm_option.series[0].data.push((d.data1[i].netvalue*1).toFixed(2));
                        }
                    }
                    /*基金规模柱状图*/
                    var jjgmChart = echarts.init(document.getElementById('jjgmcharts'));
                    jjgmChart.setOption(jjgm_option);
                }
                else{
                    if(typeof d.data1!='undefined' && d.data1.length!=0){
                        d.data1.reverse();
                    }
                    d.companyname = fundInfo.data[0].companyabbr;
                    d.sptype = fundInfo.data[0].sptype;
                    if(typeof fundInfo.data[0].riskurl!='undefined'){
                        d.riskurl = fundInfo.data[0].riskurl;
                    }
                    d.showindexflag = fundInfo.data[0].showindexflag;
                    d.hasmonthreport = fundInfo.data[0].hasmonthreport;
                    //获取一下基金详情接口获取到的基金经理姓名
                    d.managename=[];
                    if(fundInfo.data2.length!=0){
                        for(var j = 0;j<fundInfo.data2.length;j++){
                            d.managename.push(fundInfo.data2[j].name);
                        }
                    }

                    //视频介绍入口
                    d.liveflag = fundInfo.data[0].liveflag;
                    d['liveid'] = Com.getQueryStringByName('liveid');
                    d['livetype'] = Com.getQueryStringByName('livetype');
                    d['livename'] = Com.getQueryStringByName('livename');

                    var oHtml1 = $(template('jjgkmaindemo', d));
                    $('#jjgkinfomain').html(oHtml1);

                    if(typeof F.fundScan.jjjlldt!='undefined'){
                        //如果未满三个月，没有基金扫描数据
                        if(F.fundScan.jjjlldt=='hide'){
                            $('#jjjlldt').css('display','none');
                            $('#jjmanges').removeClass('displaynone');
                        }else{
                            $('#jjjlldt').css('display','block');
                            $('#jjmanges').addClass('displaynone');
                        }
                    }
                }
            }
            else if(d.result[0].code == '11' || d.result[0].code == '18' || d.result[0].code == '19'){
                return false;
            }
            else{
                Com.showNativeAlert("",d.result[0].msg,["确定"],'');
            }
        },
        "isTradeLogin":false,
        "error":function(){
            Com.ajaxLoaded();
            blackTipBlock('网络不给力|getfundscale',2000)
        }
    });
}


//老基金-货币基金-基金概况
function hbfundInfo(companyId){
    var param = {};
    param['companyId'] = companyId;
    Com.ajax({
        "url":Com.getOrigin()+"/gsfinancing/jjsm/gejjxqcompany/1.0",
        "data":param,
        "type":"post",
        "dataType":"json",
        "success":function(d){
            if(d.result[0].code == '0'){
                if(typeof fundInfo!='undefined' && fundInfo.data.length!=0){
                    if(fundInfo.data[0].isindex=='1'){
                        //优先判断是不是指数型
                        fundInfo.data[0].oftype='8';
                    }
                }
                d.oftype= fundInfo.data[0].oftype;
                d.secuabbr= fundInfo.data[0].secuabbr;
                d.ofcode= fundInfo.data[0].ofcode;
                d.hasmonthreport = fundInfo.data[0].hasmonthreport;
                //获取一下基金详情接口获取到的基金经理姓名
                d.managename=[];
                if(fundInfo.data2.length!=0){
                    for(var i = 0;i<fundInfo.data2.length;i++){
                        d.managename.push(fundInfo.data2[i].name);
                    }
                }

                //视频介绍入口
                d.liveflag = fundInfo.data[0].liveflag;
                d['liveid'] = Com.getQueryStringByName('liveid');
                d['livetype'] = Com.getQueryStringByName('livetype');
                d['livename'] = Com.getQueryStringByName('livename');

                var oHtml1 = $(template('hbfundgk', d));
                $('#hb_company').html(oHtml1);
            }
            else if(d.result[0].code == '11' || d.result[0].code == '18' || d.result[0].code == '19'){
                return false;
            }
            else{
                Com.showNativeAlert("",d.result[0].msg,["确定"],'');
            }
        },
        "isTradeLogin":false,
        "error":function(){
            Com.ajaxLoaded();
            blackTipBlock('网络不给力|gejjxqcompany',2000)
        }
    });
}


//老基金-指数型基金-查指数详情
function getIndexFundDetail(indexid){
    var param = {};
    param['SecuID'] = indexid;
    Com.ajax({
        "url":Com.getOrigin()+"/gsfinancing/uv/getUVDetail/2.0",
        "data":param,
        "type":"post",
        "dataType":"json",
        "success":function(d){
            if(d.result[0].code == '0'){
                if(typeof fundInfo!='undefined' && fundInfo.data.length!=0){
                    if(fundInfo.data[0].isindex=='1'){
                        //优先判断是不是指数型
                        fundInfo.data[0].oftype='8';
                    }
                }
                if(typeof d.data!='undefined' && d.data.length!=0){
                    getCompareData(indexid, d.data[0]);
                }

            }
            else if(d.result[0].code == '11' || d.result[0].code == '18' || d.result[0].code == '19'){
                return false;
            }
            else{
                Com.showNativeAlert("",d.result[0].msg,["确定"],'');
            }
        },
        "isTradeLogin":false,
        "error":function(){
            Com.ajaxLoaded();
            blackTipBlock('网络不给力|gejjxqcompany',2000)
        }
    });
}


//老基金-指数型基金-对比阶段性涨幅
function getCompareData(indexid,obj){
    var param = {};
    param['indexid'] = indexid;
    obj.SecuID = indexid;
    Com.ajax({
        "url":Com.getOrigin()+"/gsfinancing/fundinfo/getindexquoteinfo/1.0",
        "data":param,
        "type":"post",
        "dataType":"json",
        "success":function(d){
            if(d.result[0].code == '0'){
                if(typeof d.data!='undefined' && d.data.length!=0){
                    d['indexdata']=obj;
                    var oHtml1 = $(template('indexDetailsDemo', d));
                    $('#gzindex').html(oHtml1);

                    if(d.data.length>1){
                        compareindex.series[0].length = d.data.length;
                        for(var i = 0;i<d.data.length;i++){
                            compareindex.series[i].data = [d.data[i].changepct1w,d.data[i].changepct1m,d.data[i].changepct3m];
                        }

                        /*阶段性涨幅对比*/

                        var jjgmChart = echarts.init(document.getElementById('jdzdfcharts'));
                        jjgmChart.setOption(compareindex);
                    }



                }
            }
            else if(d.result[0].code == '11' || d.result[0].code == '18' || d.result[0].code == '19'){
                return false;
            }
            else{
                Com.showNativeAlert("",d.result[0].msg,["确定"],'');
            }
        },
        "isTradeLogin":false,
        "error":function(){
            Com.ajaxLoaded();
            blackTipBlock('网络不给力|gejjxqcompany',2000)
        }
    });

}


//老基金-重仓股
function highHoldList(secuid){
    var param = {};
    param['secuid'] = secuid;
    Com.ajax({
        "url":Com.getOrigin()+"/gsfinancing/fundinfo/getfundcapinfo/2.0",
        "data":param,
        "type":"post",
        "dataType":"json",
        "success":function(d){
            if(d.result[0].code == '0'){

                if(typeof d.data2!='undefined'){
                    if(d.data2.length<=5){
                        d.data2.pop();
                    }
                }

                /*587版本需求，非QDII基金，将原来的行业换成涨跌幅*/
                for(var i = 0;i<d.data2.length;i++){
                    d.data2[i].updownprice='';
                    if(typeof d.data2[i].curprice!='undefined' && d.data2[i].curprice!='' &&typeof d.data2[i].closeprice!='undefined' && d.data2[i].closeprice!=''){

                        if(d.data2[i].curprice*1==0||d.data2[i].closeprice*1==0){
                            d.data2[i].updownprice='0.00';
                        }else{
                            if(!isNaN(d.data2[i].curprice) && !isNaN(d.data2[i].closeprice)){
                                d.data2[i].updownprice = (((d.data2[i].curprice*1-d.data2[i].closeprice*1)/d.data2[i].closeprice*1)*100).toFixed(2);
                            }
                        }
                    }
                }

                var oHtml1 = $(template('holdhighstocks', d));
                $('#holdhighbox').html(oHtml1);

                $('.titleboxmain').width($(window).width()*0.3);
            }
            else if(d.result[0].code == '11' || d.result[0].code == '18' || d.result[0].code == '19'){
                return false;
            }
            else{
                Com.showNativeAlert("",d.result[0].msg,["确定"],'');
            }
        },
        "isTradeLogin":false,
        "error":function(){
            Com.ajaxLoaded();
            blackTipBlock('网络不给力|getfundcapinfo',2000)
        }
    });

}


/*老基金---基金经理雷达图*/
//获取并展示基本信息和页面初始状态
F.fundScan.baseInfo = function(mfcode){
    var param = {};
    param['mfcode'] = mfcode;
    Com.ajax({
        "url":Com.getOrigin()+"/gsfinancing/jjsm/baseAndMgrInfo/1.0",
        "data":param,
        "type":"post",
        "dataType":"json",
        "success":function(d){
            if (d != null && d.result[0].code == 0) {
                if(typeof d.hide!='undefined'){

                    //如果未满三个月，没有基金扫描数据
                    $('#jjjlldt').css('display','none');
                    $('#jjmanges').removeClass('displaynone');
                    F.fundScan.jjjlldt='hide';
                }else{
                    F.fundScan.jjjlldt='';
                    $('#jjjlldt').css('display','block');
                    $('#jjmanges').addClass('displaynone');
                    if(typeof d.jjsmInfo!='undefined'){
                        d.jjsmInfo[0].ofcode = fundInfo.data[0].ofcode;
                    }
                    var oHtml1 = $(template('fundmanageinfo', d));
                    $('#jjjlldt').html(oHtml1);

                    setTimeout(function(){
                        $('.radar .bg').show();
                        F.fundScan.showFundManagerinfo(d);
                    },100);

                    F.fundScan.toggleFundManagers();
                }
            }else{
                Com.nativeToast(d.result[0].code+':'+d.result[0].msg);
            }
        },
        "isTradeLogin":false,
        "error":function(){
            Com.ajaxLoaded();
            blackTipBlock('网络不给力|baseAndMgrInfo',2000)
        }
    });
};

//点击切换基金经理
F.fundScan.toggleFundManagers = function(){
    $('.mngname').click(function(){
        if($(this).hasClass('on')){
            return;
        }
        var that = $(this);
        var smdate = that.attr('smdate');
        var ofcode = that.attr('ofcode');
        var personalID = that.attr('personalid');
        var param = {};
        $('.mngname').removeClass('on');
        $(that).addClass('on');
        param['mfcode'] = ofcode;
        param['smdate'] = smdate;
        param['personalID'] = personalID;
        Com.ajax({
            "url":Com.getOrigin()+"/gsfinancing/jjsm/managerInfo/1.0",
            "data":param,
            "type":"post",
            "dataType":"json",
            "success":function(respone){
                if (respone != null && respone.result[0].code == 0) {
                    respone.curManagerList = [{
                        mfmgr:$(that).attr('mfmgr'),
                        accessdays:$(that).attr('accessdays'),
                        personalID:$(that).attr('personalid')
                    }];

                    /*var oHtml1 = $(template('redrawchartsmag', respone));
                    $('#managechartsbox').html(oHtml1);*/
                    var oHtml1 = $(template('redrawchartsmag_1', respone));
                    $('#managerinfot').html(oHtml1);
                    var oHtml2 = $(template('redrawchartsmag_2', respone));
                    $('#manaagerchartsbox').html(oHtml2);

                    F.fundScan.showFundManagerinfo(respone);
                }else{
                    Com.nativeToast(respone.result[0].code+':'+respone.result[0].msg);
                }
            },
            "isTradeLogin":false,
            "error":function(){
                Com.ajaxLoaded();
                blackTipBlock('网络不给力|baseAndMgrInfo',2000)
            }
        });
    });
};


/*业绩走势*/
//历史收益率
var yjzsoptions = {
    title: {
        show:false,
        padding:0,
        text: '收益率'
    },
    legend: {
        show:false,
        data:['收益率']
    },
    animation:false,
    toolbox: {
        show:false,
        feature: {
            saveAsImage: {}
        }
    },
    grid: {
        left: '10px',
        right: '10px',
        bottom: '10px',
        top:'8px',
        containLabel: true
    },
    xAxis : [
        {
            type : 'category',
            boundaryGap : false,
            data : [{
                value:'2017-07-24',
                textStyle:{
                    color:'#8e8e93',
                    fontSize:11,
                    align:'left'
                }
            },'','','','','','2017-07-25'],
            axisLabel:{
                textStyle:{
                    color:'#8e8e93',
                    fontSize:11,
                    align:'right'
                },
                interval:0,
                margin:15,
                formatter: function (value, index) {
                    return value;
                }
            },
            axisLine: {            // 坐标轴线
                lineStyle: {       // 属性lineStyle控制线条样式
                    color: '#f6f6f7'
                },
                show:false
            },
            axisTick: {            // 坐标刻度
                show:false
            },
            splitLine: {           // 分隔线
                interval:30,
                show:true,
                lineStyle: {       // 属性lineStyle（详见lineStyle）控制线条样式
                    color: ['#f6f6f7']
                }
            }
        }
    ],
    yAxis : [
        {
            type : 'value',
            splitLine: {           // 分隔线
                lineStyle: {       // 属性lineStyle（详见lineStyle）控制线条样式
                    color: ['#f6f6f7'],
                    type:'dashed'  //'solid'  'dashed'  'dotted'
                }
            },
            axisLine: {            // 坐标轴线
                show:false,
                lineStyle: {       // 属性lineStyle控制线条样式
                    color: '#f6f6f7'
                }
            },
            axisLabel:{
                // inside:true,
                textStyle:{
                    color:'#8e8e93',
                    baseline:'middle',
                    fontSize:11
                },
                formatter: function (value, index) {
                    return (value*1).toFixed(2)+'%';
                }
            },
            axisTick:{
                show:false
            },
            splitNumber:4
        }
    ],
    series : [
        {
            name:'本基金累计收益',
            type:'line',
            // stack: '总量',
            data:[],
            areaStyle: {
                normal: {
                    color:'transparent'
                },
                smooth:true
            },
            lineStyle:{
                normal:{
                    width:1,
                    color:'#FC4747'
                }
            },
            animation:false,
            itemStyle:{
                normal : {
                    color:'#FC4747',
                    lineStyle:{
                        color:'#FC4747'
                    }
                }
            },
            showSymbol :false
        },
        {
            name:'沪深300收益率',
            type:'line',
            // stack: '总量',
            data:[],
            animation:false,
            areaStyle: {
                normal: {
                    color:'transparent'
                },
                smooth:true
            },
            lineStyle:{
                normal:{
                    width:1,
                    color:'#589DFC'
                }
            },
            itemStyle:{
                normal : {
                    color:'#589DFC',
                    lineStyle:{
                        color:'#589DFC'
                    }
                }
            },
            showSymbol :false
        },
        {
            name:'同类平均收益率',
            type:'line',
            // stack: '总量',
            data:[],
            animation:false,
            areaStyle: {
                normal: {
                    color:'transparent'
                },
                smooth:true
            },
            lineStyle:{
                normal:{
                    width:1,
                    color:'#FFCF79'
                }
            },
            itemStyle:{
                normal : {
                    color:'#FFCF79',
                    lineStyle:{
                        color:'#FFCF79'
                    }
                }
            },
            showSymbol :false
        }
    ]
};
//老基金-业绩走势
var yjzscharts;
/**
 * profit_hs300沪深300
 * profit_zzqz 中证全债
 * profit_szzs 上证指数
 * profit_szcz 深证成指
 * profit_cybz 创业板指
 * profit_zxbz  中小板指
 * profit_zz500 中证500指数
 * @type {string}
 */

var yjzsdataObj = [];/*保存图表接口返回的结果集*/
function yjChartsAjax(querytime,noneedrequst){
    var param = {};
    var querydur=dataObj.choosetime;//默认查近一月的数据
    var oftype = fundInfo.data[0].oftype;
    param['mfid'] = fundInfo.data[0].secuid;
    if(typeof querytime!='undefined' && querytime!=''){
        querydur = querytime;
    }
    param['period'] = querydur;
    yjzsoptions.xAxis[0].data=[];
    yjzsoptions.series[0].data=[];
    yjzsoptions.series[1].data=[];
    yjzsoptions.series[2].data=[];
    var drawHandle = function(d){
        /*画图表*/
        for(var i=0;i< d.data.length;i++){
            //x轴日期只显示首末两个值，其他都置空
            if (i==0) {
                //yjzsoptions.xAxis[0].data[i] = d.data[i].tradingdate
                yjzsoptions.xAxis[0].data[i] = {
                    value:(d.data[i].tradingdate).replace(/\//g,'-'),
                    textStyle:{
                        color:'#8e8e93',
                        fontSize:11,
                        align:'left'
                    }
                };

                //x轴日期的最后一个值需要居右
            }else if(i==d.data.length-1) {
                yjzsoptions.xAxis[0].data[i] = (d.data[i].tradingdate).replace(/\//g,'-');
                var pt;
                //非债券型基金，如果是指数基金，看看跟踪的指数是不是以下几种，如果不是，默认沪深300
                pt=((d.data[i][dataObj.chooseindex])*100).toFixed(2);
                if(isNaN(pt)){
                    pt='--';
                }
                var oHtml1 = $(template('jyzstitledemo', {'profit':((d.data[i].profit)*100).toFixed(2),'profit_type':((d.data[i].profit_type)*100).toFixed(2),'profit_hs300orprofit_zzqz':pt,'oftype':oftype,'indexname':dataObj.indexname}));
                $('#yjzxhtml').html(oHtml1);


            }else{
                yjzsoptions.xAxis[0].data[i] =  '';

            }
            yjzsoptions.series[0].data[i]=(d.data[i].profit*100);
            if(oftype==3){
                //债券型展示的数据是中证全债数据
                yjzsoptions.series[1].data[i]=(d.data[i].profit_zzqz*100);
            }else{
                //非债券型基金，如果是指数基金，看看跟踪的指数是不是以下几种，如果不是，默认沪深300
                yjzsoptions.series[1].data[i]=(d.data[i][dataObj.chooseindex]*100);
            }
            yjzsoptions.series[2].data[i]=(d.data[i].profit_type*100);
        }
        //console.log(yjzsoptions.xAxis[0].data.length)
        yjzsoptions.xAxis[0].splitLine.interval = Math.floor(d.data.length-1);
        yjzscharts = echarts.init(document.getElementById('canvas0'));
        yjzscharts.clear();
        yjzscharts.setOption(yjzsoptions,true);
    };
    var ajaxData = function(){
        Com.ajax({
            "url":Com.getOrigin()+"/gsfinancing/jjsm/getjjxqfundperformplot/1.0",
            "data":param,
            "type":"post",
            "dataType":"json",
            "success":function(d){
                if(d.result[0].code == '0'){
                    if(typeof d.data !== 'undefined' && d.data.length != 0){
                        yjzsdataObj = d;
                        drawHandle(d);

                    }else{
                        //图表暂无数据
                        var ofstatus = Com.getLocalValue('ofstatus');
                        if(!$('.nochartsData').length){
                            var nodata = $('<div class="nochartsData"><img src="../../common/images/no_data.png" width="120"><div>暂无数据</div></div>');
                            $('.det_tabs').append(nodata).find('.det_c_des').hide();
                            $('#chartsSection').hide();
                        }
                        return false;
                    }
                }
                else if(d.result[0].code == '11' || d.result[0].code == '18' || d.result[0].code == '19'){
                    return false;
                }
                else{
                    //Com.showNativeAlert("","未查询到相关图表数据!",["确定"],'');
                    Com.showNativeAlert("", d.result[0].msg,["确定"],'');
                }
                //console.log(d)
            },
            "isTradeLogin":false,
            "error":function(){
                Com.ajaxLoaded();
                blackTipBlock('网络不给力',2000)
            }
        });
    };
    if(typeof noneedrequst!='undefined' && noneedrequst==true){
        if(yjzsdataObj.result[0].code == '0'){
            if(typeof yjzsdataObj.data !== 'undefined' && yjzsdataObj.data.length != 0){
                drawHandle(yjzsdataObj);
            }
        }
    }else{
        ajaxData();
    }
}


//查询当前基金有无运营配置(基金专题模板)/*587版本去掉了*/
/*function isShowFundactivity(ofcode){
    var ofcode = ofcode;
    var param = {};
    param['ofcode'] = ofcode;
    //Com.ajaxLoading();
    var ajaxData = function(){
        Com.ajax({
            "url":Com.getOrigin()+"/gsfinancing/topic/getTopicOfFund/1.0",
            "data":param,
            "type":"post",
            "dataType":"json",
            "success":function(d){
                Com.ajaxLoaded();
                if(d.result[0].code == 0){
                    if(typeof d.data!='undefined' && d.data.length!=0 && d.data[0].curstep==1){
                        if($('#jjjdisshow').length>0){
                            $('#jjjdisshow').removeClass('displaynone');
                        }
                    }

                }
                else if(d.result[0].code == '11' || d.result[0].code == '18' || d.result[0].code == '19'){
                    return false;
                }
                else{
                    Com.showNativeAlert("",d.result[0].msg,["确定"],"");
                }
            },
            "isTradeLogin":false,
            "error":function(){
                Com.ajaxLoaded();
                blackTipBlock('网络不给力|getTopicOfFund',2000)
            }
        });
    };
    ajaxData();
}*/
/*查询财富号有没有最新动态*/
function getCfhNewInfo(ofcode,obj){
    var param = {};
    param['ofcode'] = ofcode;
    var ajaxData = function(){
        Com.ajax({
            "url":Com.getOrigin()+"/gsfinancing/cfh/getcfharticlebyofcode/1.0",
            "data":param,
            "type":"post",
            "dataType":"json",
            "success":function(d){
                if(d.result[0].code == 0){
                    if(d.data.length!=0 && d.data!=null){
                        if(d.data.length!=0){
                            var oHtml1 = $(template('cfhDemo', d.data[0]));
                            $('#cfhbox').html(oHtml1);
                        }
                    }
                    //如果有财富号，重新渲染底部按钮
                    if (typeof d.data2!='undefined' && d.data2!=null){
                        d.data2[0] = $.extend(d.data2[0],obj);
                        var oHtml3 = $(template('buttonbox', d.data2[0]));
                        //底部按钮
                        $('#bottombtn').html(oHtml3);

                        //是否为自选基金
                        Com.isZxFund(ofcode,isZxJsCallback);
                    }
                }
                else if(d.result[0].code == '11' || d.result[0].code == '18' || d.result[0].code == '19'){
                    return false;
                }
                else{
                    Com.showNativeAlert("",d.result[0].msg,["确定"],"");
                }
            },
            "isTradeLogin":false,
            "error":function(){
                Com.ajaxLoaded();
                blackTipBlock('网络不给力|getcfharticlebyofcode',2000);
            }
        });
    };
    ajaxData();
}

//老基金-QDII重仓股
function getQDIIHold(secuid){
    var param = {};
    param['secuid'] = secuid;
    Com.ajax({
        "url":Com.getOrigin()+"/gsfinancing/fundinfo/getfundqdiicapinfo/1.0",
        "data":param,
        "type":"post",
        "dataType":"json",
        "success":function(d){
            if(d.result[0].code == '0'){

                if(typeof d.data2!='undefined'){
                    if(d.data2.length<=5){
                        d.data2.pop();
                    }
                }
                d.transfundtype = 'QDII';
                var oHtml1 = $(template('holdhighstocks', d));
                $('#holdhighbox').html(oHtml1);

                $('.titleboxmain').width($(window).width()*0.3);
            }
            else if(d.result[0].code == '11' || d.result[0].code == '18' || d.result[0].code == '19'){
                return false;
            }
            else{
                Com.showNativeAlert("",d.result[0].msg,["确定"],'');
            }
        },
        "isTradeLogin":false,
        "error":function(){
            Com.ajaxLoaded();
            blackTipBlock('网络不给力|getfundcapinfo',2000)
        }
    });
}

//当前市盈率的位置
template.helper('mask_leftposition', function (obj) {
    var marginLeft = '-28px;';
    if(obj.PETTM50Percentile > 10){
        marginLeft = '-31px;';
    }
    return 'left:'+obj.PETTMCur5Y+'%;margin-left:'+marginLeft;
});

//财富号的动态标题超出30个字符显示...
template.helper('contentctr', function (str) {
    if(typeof str=='undefined' || str==''){
        return '--';
    }
    if(typeof str !='string'){
        str.toString();
    }
    var ctrstr =str;
    if(str.length>30){
        ctrstr = str.substring(0,30)+'...';
    }
    return ctrstr;
});


//获取基金交易信息
function getTradeInfo(ofcode,cb){
    var param = {};
    param['ofcode'] = ofcode;
    Com.ajax({
        "url":Com.getOrigin()+"/gsfinancing/fundtranstepdate/gettranstepdate/1.0",
        "data":param,
        "type":"post",
        "dataType":"json",
        "success":function(d){
            cb && cb(d);
        },
        "isTradeLogin":false,
        "error":function(){
            cb && cb();
        }
    });
}

//查询定投信息
function getDtInfo(ofcode,secuid,cb){
    var param = {};
    param['ofcode'] = ofcode;
    param['secuid'] = secuid;
    Com.ajax({
        "url":Com.getOrigin()+"/gsfinancing/ofschedule/getAipYieldInfo/1.0",
        "data":param,
        "type":"post",
        "dataType":"json",
        "success":function(d){
            if(d.result[0].code=='0'){
                cb && cb(d);
            }
        },
        "isTradeLogin":false,
        "error":function(){

        }
    });
}

/*全屏说明层换行标识*/
function splitStr(){
    var clientType =Com.clientType();
    var splitStr='<br/>';
    if(clientType=='ios'){
        splitStr='\n';
    }
    dataObj.splitStr = splitStr;
}


/*按照某个数组json中的key的value值进行降序排序*/
function comparesort(propertyName) {
    return function(object1, object2) {
        var value1 = object1[propertyName];
        var value2 = object2[propertyName];
        if(value2 < value1) {
            return -1;
        } else if(value2 > value1) {
            return 1;
        } else {
            return 0;
        }
    }
}



/*获取基金解读信息*/
function getjjjdinfo (ofcode){
    var param = {};
    param['ofcode'] = ofcode;
    param['fundtradeflag'] = '0';
    Com.ajax({
        "url":Com.getOrigin()+"/gsfinancing/sf/getfundliveinfo/1.0",
        "data":param,
        "type":"post",
        "dataType":"json",
        "success":function(d){
            if(d.result[0].code == '0'){
                if(typeof d.data!='undefined' && d.data.length>0){
                    dataObj.jjjdvideo = d.data[0];
                    dataObj.hasvideo = (typeof d.data[0].liveid!='undefined' && d.data[0].liveid!='');
                    dataObj.haspiccontent = (typeof d.data[0].pturl!='undefined' && d.data[0].pturl!='');
                    if(dataObj.hasvideo || dataObj.haspiccontent){
                        $('.newfundmenu').removeClass('on').eq(0).addClass('on');
                        $('.mgtabs').css('display','none').eq(0).css('display','block');
                        $('#jjgkbox').css('display','none');
                        $('.flbox').css('display','none');
                        $('#jjjdmenu').css('display','block');
                    }else{
                        $('.newfundmenu').removeClass('on').eq(1).addClass('on');
                        $('.mgtabs').css('display','none').eq(1).css('display','block');
                        $('#jjgkbox').css('display','block');
                        $('#jjjdmenu').css('display','none');
                    }
                }
                var oHtml1 = $(template('jjjdDemo', d));
                $('#jjjdmain').html(oHtml1);
            }
        },
        "isTradeLogin":false,
        "error":function(){
            //Com.showNativeAlert('','网络不给力|getallowbsflags',['确定'],'')
        }
    });
}


//金额加逗号1000000--->1,000,000
template.helper('amtfmtsy', function (str) {
    return numFormat(str);
});

/*金额加逗号*/
function numFormat(num) {
    num = num+'';
    var splitarry=[];
    var fmtnum  = '';
    splitarry = num.split('.');
    fmtnum = (splitarry[0].toString().replace(/(\d)(?=(?:\d{3})+$)/g, '$1,'))+(splitarry.length>1&&splitarry[1]*1>0 ? '.'+splitarry[1]:'');
    return fmtnum;
}


/*查询系统时间是不是交易日期*/
function getTradeTime(cb){
    var param = {};
    var isTradeLoginFlag=false;
    var ajaxData = function(){
        Com.ajax({
            "url":Com.getOrigin()+"/gsfinancing/trade/getSysStatus/1.0",
            "data":param,
            "type":"post",
            "dataType":"json",
            "success":function(d){
                var isTradeTime=false;
                if(d.result[0].code == '0'){
                    if(d.data && d.data.length>0){
                        /*tradedate是当前交易日期  sysdate是当前物理日期 当两者相等说明今天并且是交易日*/
                        if(typeof d.data[0].tradedate!='undefined'&&typeof d.data[0].sysdate!='undefined'&&d.data[0].tradedate==d.data[0].sysdate){
                            if(typeof d.data[0].systime!='undefined'&&d.data[0].systime>='093000' && d.data[0].systime<='150000'){
                                /*当前是交易时间段*/
                                isTradeTime=true;
                            }
                        }
                        d.data[0].isTradeTime = isTradeTime;
                    }else{
                        d.data=[{"isTradeTime":isTradeTime}];
                    }
                }else{
                    d.data=[{"isTradeTime":isTradeTime}];
                }
                cb && cb(d.data[0]);
            },
            "isTradeLogin":isTradeLoginFlag,
            "supportBioLogin":'2',
            "error":function(){
                cb && cb([{"isTradeTime":false}]);
                //Com.showNativeAlert('','网络不给力|getallowbsflags',['确定'],'')
            }
        });
    };
    /*如果交易登录了，送交易参数，这里这样做的原因是：交易登录之后送交易参数，中后台会以此次送的交易参数的核心为准*/
    Com.isTradelogin2(function(){
        isTradeLoginFlag = true;
        ajaxData();
    },function(){
        isTradeLoginFlag = false;
        ajaxData();
    },{},'2');
}

//时间拆分HHMM------>HH:MM
template.helper('timeft', function (str) {
    if(str==''){
        return '--';
    }
    if(str.length==4){
        return dateYear = (str.substring(0,2))+':'+(str.substring(2,4));
    }
    return str;
});

/*589新增查询当前时间是不是在周一至周五并且是09:30至15:00之间*/
function getLocalTradetime(){
    var date = new Date();
    var day = date.getDay();
    var hours = (date.getHours())*1;
    var minutes = (date.getMinutes())*1;

    if(day!='0'&&day!='6'){
        if((hours==9&&minutes>=30)||(hours>=10&&hours<15)||(hours==15&&minutes<1)){
            return true;
        }
    }
    return false;
}

/*获取是否已订阅场外基金开售提醒*/
function getIsReminded(ofcode,tacode,cb){
    var istradeLogin=false;
    var ajaxData=function(){
        var param = {};
        param['ofcode'] = ofcode;
        param['tacode'] = tacode;
        Com.ajax({
            "url":Com.getOrigin()+"/gsfinancing/notification/fund/getNotifyStatus/1.0",
            "data":param,
            "type":"post",
            "dataType":"json",
            "success":function(d){
                var notifystatus=false;
                if(d.result[0].code == 0){
                    if(d.data.length>0){
                        /*已订阅*/
                        notifystatus = (typeof d.data[0].notifystatus!='undefined' &&d.data[0].notifystatus=='1');
                    }
                }
                cb&&cb(notifystatus);
            },
            "supportBioLogin":'2',
            "isTradeLogin":istradeLogin,
            "error":function(){
                cb&&cb(false);
            }
        });
    };
    Com.isTradelogin2(function(){
        ajaxData();
        istradeLogin = true;
    },function(){
        ajaxData();
        istradeLogin = false;
    },{},'2');
}
/*订阅/取消场外基金开售提醒*/
function remindedReq(ofcode,tacode,actionflag,cb){
    var istradeLogin=false;
    var ajaxData=function(){
        var param = {};
        param['ofcode'] = ofcode;
        param['tacode'] = tacode;
        param['actionflag'] = actionflag;/*0订阅 1取消订阅*/
        Com.ajaxLoading();
        Com.ajax({
            "url":Com.getOrigin()+"/gsfinancing/notification/fund/subscribeNotify/1.0",
            "data":param,
            "type":"post",
            "dataType":"json",
            "success":function(d){
                Com.ajaxLoaded();
                if(d.result[0].code == 0){
                    /*订阅成功*/
                    cb&&cb('1');
                }
                else if(d.result[0].code == 5000){
                    Com.showNativeAlert('','已经订阅过，无须重复订阅。',['确定'],function(){
                        cb&&cb('0');
                    });
                }
                else{
                    Com.showNativeAlert('',d.result[0].msg,['确定'],function(){
                        cb&&cb('0');
                    });
                }
            },
            "supportBioLogin":'2',
            "isTradeLogin":istradeLogin,
            "error":function(){
                Com.ajaxLoaded();
                cb&&cb('0');
            }
        });
    };
    Com.isTradelogin2(function(){
        ajaxData();
        istradeLogin = true;
    },function(){
        ajaxData();
        istradeLogin = false;
    },{},'2');
}


/*获取当前客户是不是游客*/
function getUserType (cb) {
    Com.getCommonLoginData(function(param){
        //pmram.userType 1:注册用户 0游客 2其他第三方登录用户
        var _usertype='0';
        if(typeof param.userType != 'undefined'){
            _usertype = param.userType;
        }else{
            //老版本的不存在游客模式，直接当注册用户处理
            _usertype = '1'
        }
        cb && cb(_usertype,param);
    });
}

/*开售提醒订阅*/
function dingyueHandle(ofcode,tacode){
    var chdHandle = function(nativparm){
        if(dataObj.isreminded){
            return;
        }
        if(!dataObj.isremindBtnSatus){
            return;
        }
        var loginafterHandle=function(nativparm){
            dataObj.isremindBtnSatus = false;
            if(Com.comparieVersion('4.1.0', dataObj.sysVer)){
                //金太阳当前版本大于等于4.1.0版本
                Com.showNativeAlert("",'在此基金认购首日，当前登录的手机号'+nativparm.netAddr+'，可收到站内"信息快线"通知',["取消","立即订阅"],function(pm){
                    if(pm.clickedIndex == '1'){
                        //开始订阅
                        remindedReq(ofcode,tacode,'0',function(flag){
                            if(typeof flag!='undefined' && flag=='1'){
                                /*订阅成功*/
                                dataObj.isreminded = true;
                                fundInfo.data[0].notifystatus = '1';
                                var oHtml3 = $(template('buttonbox', fundInfo.data[0]));//底部按钮
                                $('#bottombtn').html(oHtml3);
                                Com.showNativeAlert("",'恭喜订阅成功！请保持信息设置为开启状态，以免接收不到提醒',["查看设置","确定"],function(pm){
                                    if(pm.clickedIndex == '0'){
                                        //跳转到信息设置界面
                                        Com.openNativePage('xxsz','fun','');
                                    }
                                });
                            }else{
                                dataObj.isremindBtnSatus = true;
                            }
                        })
                    }else{
                        dataObj.isremindBtnSatus = true;
                    }
                });
            }else{
                Com.showNativeAlert('', '请升级版本接收推送消息',['确定'],function(){
                    dataObj.isremindBtnSatus = true;
                });
            }
        };
        loginafterHandle(nativparm);
        /*Com.actionLogin(function(){
         loginafterHandle();
         },{},null,'2');*/
    };

    getUserType(function(utype,nativparm){
        if(utype==1){
            chdHandle(nativparm);
        }else{
            Com.openNativePage('zcdl','fun');
            dataObj.isCallNativeRegPage = true;
        }
    })

}

/*返回刷新之后执行*/
function refreshFunc(){
    if(dataObj.isCallNativeRegPage){
        dataObj.isremindBtnSatus = true;

        //紧接着把标记设置成false，防止继续执行返回刷新（因为从注册登录界面返回回来，只需要执行一次该方法就可以了，让整个流程连续起来）
        dataObj.isCallNativeRegPage=false;

        /*表示是点击开售提醒弹出了注册登录界面，关闭之后执行以下代码*/
        dingyueHandle(fundInfo.data[0].ofcode,fundInfo.data[0].tacode);
    }
}