//万分收益数据格式化
template.helper('millionFormat', function (num) {
    return num = ((num*1).toFixed(4)).toString();
});
//收益率数据格式化
template.helper('rateFormat', function (num) {
    num = Number(num);
    return num = (num.toFixed(2)).toString()+'%';
});

//货币型基金7日年化收益率数据格式化
template.helper('deRate', function (num) {
    num = Number(num);
    return num = ((num*100).toFixed(2)).toString()+'%';
});


/*上拉刷新下拉加载*/
var myScroll,     //iscroll
    pullDownEl,   //下拉对象
    pullDownOffset,//下拉幅度
    pullUpEl,     //上拉对象
    pullUpOffset, //上拉幅度
    generatedCount = 0,
    flag=false,
    ttm = null,   //下拉刷新数据渲染定时器
    isPull = true;
function loaded() {
    pullDownEl = document.getElementById('pullDown');
    pullDownOffset = pullDownEl.offsetHeight;
    console.log(pullDownOffset);
    pullUpEl = document.getElementById('pullUp');
    pullUpOffset = pullUpEl.offsetHeight;

    myScroll = new iScroll('f_l_main', {
        useTransition: true,
        useTransform: true,
        hideScrollbar:true,
        topOffset: pullDownOffset,
        hScrollbar: false,
        vScrollbar: false,
        bounceLock:false,
        momentum:false,
        onBeforeScrollStart: function (e) {
            myScroll.refresh();
        },
        onScrollStart: function (e) {
            myScroll.refresh();

        },
        onRefresh: function () {
            if (pullDownEl.className.match('loading')) {
                if( pullDownEl.querySelector('.pullDownLabel')){
                    pullDownEl.className = '';
                    pullDownEl.querySelector('.pullDownLabel').innerHTML = '下拉刷新...';
                }

            } else if (pullUpEl.className.match('loading')) {
                if( pullUpEl.querySelector('.pullDownLabel')){
                    pullUpEl.className = '';
                    pullUpEl.querySelector('.pullUpLabel').innerHTML = '上拉加载...';
                }

            }
        },

        onScrollMove: function () {
            flag = true;
            /*修正bug*/
            if(((this.y < this.maxScrollY) && (this.pointY < 50))){
                this.scrollTo(0, this.maxScrollY, 400);
                return;
            } else if (this.y > 0 && (this.pointY > window.innerHeight - 1)) {
                this.scrollTo(0, 0, 400);
                return;
            }
            /*end*/
            if (this.y > 5 && !pullDownEl.className.match('flip')) {

                if(pullDownEl.querySelector('.pullDownLabel')){
                    pullDownEl.className = 'flip';
                    pullDownEl.querySelector('.pullDownLabel').innerHTML = '释放刷新...';
                    this.minScrollY = 0;
                }

            } else if (this.y < 5 && pullDownEl.className.match('flip')) {
                if(pullDownEl.querySelector('.pullDownLabel')){
                    pullDownEl.className = '';
                    pullDownEl.querySelector('.pullDownLabel').innerHTML = '释放加载...';
                }


                this.minScrollY = -pullDownOffset;
            } else if (this.y < (this.maxScrollY - 5) && !pullUpEl.className.match('flip')) {
                if(pullUpEl.querySelector('.pullUpLabel')){
                    pullUpEl.className = 'flip';
                    pullUpEl.querySelector('.pullUpLabel').innerHTML = '释放刷新...';
                    this.maxScrollY = this.maxScrollY;
                }

            } else if (this.y > (this.maxScrollY + 5) && pullUpEl.className.match('flip')) {
                if(pullUpEl.querySelector('.pullUpLabel')){
                    pullUpEl.className = '';
                    pullUpEl.querySelector('.pullUpLabel').innerHTML = '释放加载...';
                    this.maxScrollY = pullUpOffset;
                }

            }
        },
        onScrollEnd: function () {
            if (pullDownEl.className.match('flip')&&flag) {
                if( pullDownEl.querySelector('.pullDownLabel')){
                    pullDownEl.className = 'loading';
                    pullDownEl.querySelector('.pullDownLabel').innerHTML = '正在加载...';
                    pullDownAction();	// Execute custom function (ajax call?)
                }

            } else if (pullUpEl.className.match('flip')&&flag) {
                if(pullUpEl.querySelector('.pullUpLabel')){
                    pullUpEl.className = 'loading';
                    pullUpEl.querySelector('.pullUpLabel').innerHTML = '正在加载...';
                    pullUpAction();	// Execute custom function (ajax call?)
                }

            }
        }
    });

    setTimeout(function () { document.getElementById('f_l_main').style.left = '0'; }, 800);
}


//下拉
function pullDownAction () {
    myScroll.disable();
    if(ttm){
        clearTimeout(ttm);
    }
    ttm = setTimeout(function(){
        setTimeout(function(){
            funkRangeParam.isClear = true;
            funkRangeParam.pageNum = '0';
            fundRankData(funkRangeParam);
            if($('#thelist').find('tr').length>=20){
                $('#pullUp').show();
            }
        },500);
        myScroll.refresh();
    },2000)
}

//上拉
function pullUpAction () {
    var lilen = $('#thelist').find('tr').length;

    if(lilen<20 || isPull == false){
        return false;
    }
    $('#pullUp').show();
    myScroll.disable();
    if(ttm){
        clearTimeout(ttm);
    }
    ttm = setTimeout(function () {
        funkRangeParam.isClear = false;
        funkRangeParam.pageNum = (Number(funkRangeParam.pageNum)+1).toString();
        fundRankData(funkRangeParam);
        myScroll.refresh();

    }, 2000);
}

//显示定投排行（默认初始状态）
function showDtRank(){
    $('.sortlink').removeClass('on').find('.sorticon').removeClass('up').removeClass('down');;
    $('.fundtype').removeClass('on').eq(0).addClass('on');
    $('.zndt_rate').addClass('on').find('.sorticon').addClass('up').removeClass('down');
    $('.dtul').show().siblings('.hbul').hide().siblings('.qtul').hide();
    $('.dt_cfc').show().siblings('.hb_cfc').hide().siblings('.qt_cfc').hide();
    funkRangeParam = {'type':'','dataNum':'20','pageNum':'0','onlyFund':'1','ranktype':'ZNDT','ranksort':'0','isClear':true,'timedata':'2','isHb':false,'timeflag':'5'};
}

//判断当前页面是否只当做定投排行使用（只展示定投排行），否则正常展示基金排行和定投排行
function pageOnlyDT(){
    showDtRank();
}

/*基金排行数据*/
/**
 *
 * @param rankparam:jsonobject
 *  rankparam.type      Y   基金类型:空-全部 1-宽基，2-行业，3-主题，4-策略，5-海外，6-债券，
 *  rankparam.dataNum   Y  每页数量:
 *  rankparam.pageNum   Y  查询页数:页码从0开始
 *  rankparam.onlyFund  N  只查定投:0-否 1-是
 *  rankparam.ranktype  N  排序字段:1-单位净值，2-近1月收益率，3-近3月收益率，4-近6月收益率，5-近1年收益率，6-今年以来收益率，7-成立以来收益率，8-万份收益，9-七日年化
 如果不传，按照数据库默认顺序返回
 *  rankparam.ranksort  N  排序方向:0-降序 1-升序 (排序字段如果传值，此字段必传值)
 *  rankparam.isClear   数据渲染之前是否清空当前tabs的html
 *  rankparam.timedata  自定义数据，标识当前的时间维度：近N个月 与接口入参ordercol相对应
 *  rankparam.isHb      自定义数据，当前选中的是否是货币型基金
 *  rankparam.timeflag   20180718新增，仅当查定投时有效。查询定投排行的时间维度

 */
function fundRankData(rankparam){
    var param = {};

    var ajaxData = function(dataJson){
        Com.ajaxLoading();
        var isOnlyDT = Com.getQueryStringByName('ranktype');
        var dtrankDataUrl = '/gsfinancing/indexinvest/getScheduleRankList/1.0';
        Com.ajax({
            "url":Com.getOrigin()+dtrankDataUrl,
            "data":dataJson,
            "type":"post",
            "dataType":"json",
            "success":function(d){
                Com.ajaxLoaded();
                if(d.result[0].code == '0'){
                    if(rankparam.type==''||rankparam.type=='0'||rankparam.type=='1'||rankparam.type=='2'||rankparam.type=='3'||rankparam.type=='4'){
                        $('#zndtrate').css('display','block');
                        $('.flist_sl').addClass('center');
                    }else{
                        $('#zndtrate').css('display','none');
                        $('.flist_sl').removeClass('center');
                    }

                    if(d.data.length > 0){
                        $('#pullUp').show();
                        //将目前的条件对象一并添加到返回值当中，以便在模板当中取到funkRangeParam中的值
                        d.funkRangeParam = funkRangeParam;
                        var oHtml = $(template('funddata', d));
                        if(rankparam.isClear == true){
                            $('#thelist').html('').append(oHtml);
                            myScroll.scrollTo(0,0,0);
                        }else{
                            $('#thelist').append(oHtml);
                        }
                        $(oHtml).find('.f_l_name').each(function(index){
                            var _width;
                            if(funkRangeParam.onlyFund==1){
                                _width = $('.dtul').find('.flist_nm').width();
                            }else{
                                if(funkRangeParam.isHb==true){
                                    _width = $('.hbul').find('.flist_nm').width();
                                }else{
                                    _width = $('.qtul').find('.flist_nm').width();
                                }
                            }

                            $(this).find('.stk-name').css({'max-width': (_width-45)+'px'});
                            //mfundCom.name_substr($(this));
                        });
                        if(d.data.length<20){
                            isPull = false;
                            $('#pullUp').html('没有更多数据！');
                        }else{
                            $('#pullUp').html('<span class="pullUpIcon"></span><span class="pullUpLabel">上拉加载...</span>');
                            isPull = true;
                        }

                    }else{
                        isPull = false;
                        if(d.data.length == 0 && rankparam.pageNum == 0){
                            $('#thelist').html('<tr><td colspan="4"><div class="nodata">暂无数据</div></td></tr>').append(oHtml);
                            $('#pullUp').hide();
                        }else{
                            $('#pullUp').html('没有更多数据！');
                        }
                    }

                    // myScroll.refresh();
                }
                else if(d.result[0].code == '11' || d.result[0].code == '18' || d.result[0].code == '19'){
                    console.log(d.result[0].msg);
                }
                else{
                    Com.showNativeAlert("",d.result[0].msg,["确定"],'');
                }
                myScroll.enable();
            },
            "isTradeLogin":false,
            "error":function(){
                myScroll.enable();
                Com.ajaxLoaded();
                blackTipBlock('网络不给力',2000)
            }
        });
    };
    if(rankparam.onlyFund==1){
        //查定投
        param['indextype'] = rankparam.type;
        param['timeflag'] = rankparam.timeflag;
        param['ordercol'] = rankparam.ranktype;
        param['ordercolori'] = rankparam.ranksort;
        param['pagesize'] = rankparam.dataNum;
        param['pagenum'] = rankparam.pageNum;
        /*20181108新增入参tocade，查询指定基金公司旗下基金*/
        var companyid = Com.getQueryStringByName('companyid');
        if(companyid!=''){
            param['companyId'] = companyid;
        }
    }

    ajaxData(param);
}

/*类型筛选*/
function fundTypeData(obj){
    var oftype = obj.find('a').attr('oftype');
    obj.addClass('on').siblings().removeClass('on');
    if(oftype!='5' && oftype!='6'){
        $('.sorticon').removeClass('up').removeClass('down').eq(0).addClass('up');
    }else{
        $('.sorticon').removeClass('up').removeClass('down').eq(1).addClass('up');
    }

    $('.yearrate').removeClass('on').eq(3).addClass('on');
    $('.zndt_rate').find('i').addClass('up').removeClass('down');
    funkRangeParam.isHb = false;
    funkRangeParam.timedata = '2';
    funkRangeParam.ranktype = 'ZNDT';
    funkRangeParam.timeflag = '5';


    funkRangeParam.type = oftype;

    funkRangeParam.ranksort = '0';
    funkRangeParam.isClear = true;
    funkRangeParam.pageNum = '0';
    fundRankData(funkRangeParam);
}

/*近N年选择（定投排行）*/
function recentyears(ths){
    var $obj  = $('.yearrate');
    var oindex = $obj.index(ths);
    //$('.sorticon').removeClass('up').removeClass('down');//时间维度选择，清空排序
    $obj.removeClass('on').eq(oindex).addClass('on');

    $('.sortlink').find('i').removeClass('down').removeClass('up');
    $('.zndt_rate').find('i').addClass('up').removeClass('down');
    if(oindex == 0){
        funkRangeParam.timeflag = '1';
        funkRangeParam.ranktype = 'ZNDT';
    }
    else if(oindex == 1){
        funkRangeParam.timeflag = '2';
        funkRangeParam.ranktype = 'ZNDT';
    }
    else if(oindex == 2){
        funkRangeParam.timeflag = '3';
        funkRangeParam.ranktype = 'ZNDT';
    }
    else{
        funkRangeParam.timeflag = '5';
        funkRangeParam.ranktype = 'ZNDT';
    }
    funkRangeParam.pageNum = '0';
    funkRangeParam.ranksort = '0';
    funkRangeParam.isClear = true;
    fundRankData(funkRangeParam);
}

/*累计收益率、单位净值排序*/
function sortData(obj){
    var fx = obj.find('i');

    if(fx.hasClass('down')){
        $('.sorticon').removeClass('up').removeClass('down');
        fx.addClass('up');
        funkRangeParam.ranksort = '0';
    }else{
        $('.sorticon').removeClass('up').removeClass('down');
        fx.addClass('down');
        funkRangeParam.ranksort = '1';
    }

    if(funkRangeParam.onlyFund==1){
        if(obj.hasClass('zndt_rate')){
            //智能定投排行
            funkRangeParam.ranktype = 'ZNDT';
        }else{
            //普通定投排行
            funkRangeParam.ranktype = 'CTDT';
        }
    }else{
        if(obj.hasClass('f_dwjz')){
            //单位净值排序
            funkRangeParam.ranktype = '1';
        }
        else if(obj.hasClass('f_ljsy')){
            //累计收益率排序
            funkRangeParam.ranktype = funkRangeParam.timedata;
        }
        else if(obj.hasClass('wfsy')){
            //万分收益排序
            funkRangeParam.ranktype = '8';
        }
        else{
            //7日年化收益排序
            funkRangeParam.ranktype = funkRangeParam.timedata;
        }
    }


    funkRangeParam.isClear = true;
    funkRangeParam.pageNum = '0';
    fundRankData(funkRangeParam);
}

//在基金排行、定投排行页面上native调此方法回到首页
function fundRankGoBack(){
    mfundCom.gobackNpage(1,'');
    //window.location.href = __uri('fund_index.html');
}


//能否购买，不能购买的基金名称置灰(只针对基金排行不针对定投排行)
template.helper('issurebuy', function (status,oblydt) {
    if(status!= 0 && status != 1 && status != 6 && oblydt=='0'){
        return 'stop_buy';
    }else{
        return 'sure_buy';
    }
});
