var rankDataObj={
    topmenuactive:'dtph',
    swiper_menu:null,/*类型菜单swiper*/
    rankdata:[''],
    pagenum:0,
    pagesize:20,
    oftype:'0',/*基金类型*/
    onlytimeopen:'',/*1只查定定投 0正常取*/
    ordercol:'ZNDT',/*ZNDT智能定投 CTDT普通定投*/
    ordercolori:"0",/*0-降序 1-升序 排序字段如果传值，此字段必传值*/
    iscfh:'',/*如果是从财富号跳转到来的，地址会有这个参数*/
    cfhSearch:'',/*如果是从财富号跳转到来的，跳转到详情的时候需要固定在详情地址加参数'&channel=cfh&protype=3&brokercode=CFH_'+companyid*/
    companyId:"",/*如果只查某个基金公司的该字段从页面地址上取*/
    type:'',/*如果地址携带了具体的基金类型，取该字段并查该类型的基金数据*/
    isshowTopMenu:'',/*是否需要显示顶部的三个菜单*/
    isindex:'',/*是否是指数型*/
    timechoose:'5',/*时间维度*/
    dataEmpty:false,
    timeOutGetHeight:null,
    ishowpagetitle:true,/*是否需要设置导航栏的标题*/
    isScrollLoading:true,//当前是否可以加载数据
    clonefixedbar_top:125,
    isanumation:true,/*是否需要加载转圈动画*/
    splitStr:'\n',//全屏弹框说明文字间的分隔符
    shownodatabox:false/*是否显示暂无数据的图片*/


};
var appvue = new Vue({
    el:'#app',
    data:rankDataObj,
    created : function(){
        var self = this;
    },
    methods:{
        /*切换顶部菜单*/
        topmenuClick:function(menustr){
            if(rankDataObj.topmenuactive==menustr){
                return;
            }
            Com.ajaxLoading();
            rankDataObj.topmenuactive=menustr;
            if(menustr=='yjph'){
                window.location.href=Com.getOrigin()+'/asset/mfund/pages/fund_fr_list.html?ishowmenu=1'+rankDataObj.cfhSearch;
            }
            else if(menustr=='jzgs'){
                window.location.href=Com.getOrigin()+'/asset/mfund/pages/fund_gz_list.html?ishowmenu=1'+rankDataObj.cfhSearch;
            }
        },
        /*切换基金类型*/
        choosetype:function(typestr){
            rankDataObj.oftype=typestr;
            if(typestr==3||typestr==4||typestr==6||typestr==7||typestr==8){
                rankDataObj.ordercol = 'CTDT';
            }
            else{
                rankDataObj.ordercol = 'ZNDT';
            }
            rankDataObj.timechoose = '5';
            exports.setDefaultParam();
            exports.getGZInfoData();

            /*如果是财富号跳转过来的 有埋点*/
            if(rankDataObj.iscfh=='1'){
                var tdstr = '';
                var curtype='定投排行';
                var cid =  rankDataObj.companyId;
                var ftype = exports.oftypechn(rankDataObj.oftype);

                tdstr='首页-'+cid+'-产品列表页-'+curtype+'-'+ftype;
                TalkingData && TalkingData.onEventWithLabel('理财-公募基金-财富号', tdstr);
            }

        },
        /*切换普通定投升降序排序*/
        sorttypeHandle:function(){
            rankDataObj.ordercolori = (rankDataObj.ordercolori==0?1:0);
            rankDataObj.rankdata=[];
            rankDataObj.pagenum=0;
            rankDataObj.ordercol = 'CTDT';
            exports.getGZInfoData();
        },

        /*切换智能定投排序*/
        navsort:function(){
            rankDataObj.ordercol = 'ZNDT';
            rankDataObj.rankdata=[];
            rankDataObj.pagenum=0;
            rankDataObj.ordercolori=(rankDataObj.ordercolori==0?1:0);
            exports.getGZInfoData();
        },

        /*时间切换*/
        choosetime:function(timestr){
            rankDataObj.timechoose=timestr;
            rankDataObj.pagenum=0;
            rankDataObj.rankdata=[];
            exports.getGZInfoData();
        },
        /*跳转到详情*/
        godetails:function(obj){
            if(obj.ofcode!=''){
                Com.newWebViewOpenPage('',{'pageUrl':Com.getOrigin()+'/asset/mfund/pages/fund_details.html?ofcode='+obj.ofcode+rankDataObj.cfhSearch,"weburl":Com.getOrigin()+'/asset/mfund/pages/fund_details.html?ofcode='+obj.ofcode+rankDataObj.cfhSearch});
            }else{
                Com.showNativeAlert('','基金代码为空',['确定'],'');
            }
        },

        /*跳转到I选材*/
        ixcgo:function(){
            Com.newWebViewOpenPage('',{"pageUrl": Com.getOrigin()+'/asset/goldsun_mlc/ixc/pages/index.html?navId=1',"weburl": Com.getOrigin()+'/asset/goldsun_mlc/ixc/pages/index.html?navId=1'},'1');
        },
        zbdttipsdes:function(){
            Com.showScreenMask('定投收益率说明','按每月投资一次来计算，不包含交易手续费。'+rankDataObj.splitStr+'智能定投收益率计算公式'+rankDataObj.splitStr+' C1*(1+r/12) ^n +C2*(1+r/12)^(n-1)+... +Cn(1+r/12) ^1=NAVn '+rankDataObj.splitStr+'（n为投资期数，NAVn为第n月期末市值，r为年化收益率。Ci为第i期投入金额）'+rankDataObj.splitStr+'普通定投与智能定投计算公式相同。其中普通定投C1=C2=Cn'+rankDataObj.splitStr+'模拟历史业绩不代表基金投资收益，且模拟数据未考虑手续费、通货膨胀等因素。投资者应认真阅读拟投资基金的法律文件，了解基金的风险收益特征，并充分了解基金定投和银行零存整取等储蓄方式的区别。基金定投是引导投资者进行长期投资、平均投资成本的一种简单易行的投资方式，但是基金定投并不能规避基金投资固有风险，不能保证投资者获得收益。国信证券为基金销售机构，对基金管理人的投资运作不承担任何责任。敬请注意投资风险。');
        }

    },
    filters:{
        millionFormat:function(num){
            if(num==''){
                return '--';
            }
            return num = ((num*1).toFixed(4)).toString();
        },
        rateFormat:function(num){
            //num = Number(num);
            if(num==''){
                return '--';
            }
            return num = ((num*1).toFixed(2)).toString()+'%';
        },
        deRate:function(num){
            if(num==''){
                return '--';
            }
            return num = ((num*100).toFixed(2)).toString()+'%';
        },
        issurebuy:function(status){
            if(status!= 0 && status != 1 && status != 6){
                return 'stop_buy';
            }else{
                return 'sure_buy';
            }
        }
    }
});
var exports = {
    init:function(){
        $('#defautltempmenu').css('display','none');
        Com.ajaxLoaded();
        /*全屏说明层换行符ios和安卓不一致，所以加载的时候判断一下拿到换行符*/
        exports.splitStr();

        /*滑动加载(上滑)*/
        $(window).on('scroll',function(){
            var clonefixedbar = $('#gz_top_fixed');
            var oheight = $(document).height();
            var wheight = $(window).height();
            var wintop = $(window).scrollTop();
            if((wintop+wheight >= oheight-2) && wintop>0 && oheight>wheight){
                //Com.nativeToast('数据加载中')
                if(!rankDataObj.isScrollLoading || rankDataObj.rankdata.length==0){
                    return false;
                }
                rankDataObj.pagenum = parseInt(rankDataObj.pagenum)+1;
                exports.getGZInfoData();
            }
        });

        /*类型菜单swiper滑动初始化*/
        rankDataObj.swiper_menu = new Swiper('.swipermenu', {
            direction: 'horizontal',
            slidesPerView: '4.3',
            freeMode: false,
            freeModeMomentumRatio:false
        });

        /*初始化url上携带的参数，都存起来*/
        exports.urlparamInit();

        /*看下url地址携带的有没有指定的基金类型，如果有，则初始就加载这种类型的基金数据*/
        exports.getUrlFundType();

        /*初始化就绪，根据现有参数拿基金排行数据*/
        exports.getGZInfoData();

        /*机器人初始化，区分货币型和非货币型*/
        new Drag('fixedrobot');
        robotAction('','','','','','9905','ztl018','8','fixedrobot');

        //显示放大镜
        Com.rightTopBtn('4','',SearchCallBack,'1','');

        /*是否需要设置导航栏标题*/
        if(rankDataObj.ishowpagetitle){
            Com.setWebviewTitle('',{"title":"排行榜","bgColor":""});
        }

    },

    urlparamInit:function(){
        var isindex = Com.getQueryStringByName('isindex');
        var ishowmenu = Com.getQueryStringByName('ishowmenu');
        var iscfh = Com.getQueryStringByName('cfh');
        var companyid = Com.getQueryStringByName('companyid');
        var type = Com.getQueryStringByName('type');
        if(isindex==1){
            rankDataObj.isindex = 1;
        }
        if(typeof ishowmenu!='undefined' && ishowmenu!=''){
            rankDataObj.ishowmenu = ishowmenu;
        }
        if(typeof iscfh!='undefined' && iscfh!=''){
            rankDataObj.iscfh = iscfh;
        }
        if(typeof companyid!='undefined' && companyid!=''){
            rankDataObj.companyId = companyid;
        }
        if(iscfh == '1'){
            //财富号跳转过来的地址要加参数，到详情页面上会给虚拟推荐人绑定关系
            rankDataObj.cfhSearch = '&channel=cfh&protype=3&brokercode=CFH_'+companyid;
        }
        if(typeof type!='undefined' && type!=''){
            rankDataObj.type = type;
        }
    },

    getUrlFundType:function(){
        var swipergodis=0;
        /*如果页面地址携带了指定类型，则只查该类型数据,否则查全部*/
        rankDataObj.ordercol='ZNDT';

        rankDataObj.timechoose=5;
        if(rankDataObj.type!=''){
            switch (rankDataObj.type){
                case '0':
                    rankDataObj.oftype='0';
                    swipergodis=0;
                    break;
                case '1':
                    rankDataObj.oftype='1';
                    swipergodis=1;
                    break;
                case '2':
                    rankDataObj.oftype='2';
                    swipergodis=2;
                    break;
                case '3':
                    rankDataObj.oftype='3';
                    rankDataObj.ordercol='CTDT';
                    swipergodis=3;
                    break;
                case '4':
                    rankDataObj.oftype='4';
                    rankDataObj.ordercol='CTDT';
                    swipergodis=4;
                    break;
                case '5':
                    rankDataObj.oftype='5';
                    swipergodis=6;
                    break;
                case '6':
                    rankDataObj.oftype='6';
                    rankDataObj.ordercol='CTDT';
                    swipergodis=7;
                    break;
                case '7':
                    rankDataObj.oftype='7';
                    rankDataObj.ordercol='CTDT';
                    swipergodis=8;
                    break;
                case '8':
                    rankDataObj.oftype='8';
                    rankDataObj.ordercol='CTDT';
                    swipergodis=5;
                    break;
                default:
                    rankDataObj.oftype='0';
                    swipergodis=0;
                    break;
            }
            rankDataObj.swiper_menu.slideTo(swipergodis);
        }

    },

    setDefaultParam:function(){
        rankDataObj.rankdata=[];
        rankDataObj.pagenum=0;
        rankDataObj.ordercolori=0;
    },
    /*获取基金排行榜*/
    getGZInfoData: function (caculateOffsetTop){
        rankDataObj.shownodatabox = false;
        rankDataObj.isanumation = true;
        rankDataObj.isScrollLoading = false;
        var param = {};
        param['oftype'] = rankDataObj.oftype;
        param['timeflag'] = rankDataObj.timechoose;
        param['ordercol'] = rankDataObj.ordercol;
        param['ordercolori'] = rankDataObj.ordercolori;
        param['pagesize'] = rankDataObj.pagesize;
        param['pagenum'] = rankDataObj.pagenum;
        if(rankDataObj.companyId!=''){
            param['companyid'] = rankDataObj.companyId;
        }

        Com.ajaxLoading();
        Com.ajax({
            "url":Com.getOrigin()+"/gsfinancing/ofschedule/getRankList/1.0",
            "data":param,
            "type":"post",
            "dataType":"json",
            "success":function(d){
                Com.ajaxLoaded();
                rankDataObj.isScrollLoading = true;
                rankDataObj.isanumation = false;
                if(d.result[0].code == '0'){

                    if(d.data.length>0){
                        if(rankDataObj.pagenum==0){
                            //第一次加载
                            rankDataObj.rankdata = d.data;
                        }else{
                            for(var i = 0;i<d.data.length;i++){
                                rankDataObj.rankdata.push(d.data[i]);
                            }
                        }

                        if(d.data.length<Number(rankDataObj.pagesize)){
                            //如果当前获取到的数据小于分页条数，禁止滑动加载
                            rankDataObj.isScrollLoading = false;
                        }
                    }else{
                        //rankDataObj.rankdata=[];
                        //如果当前获取到的数据是空，禁止滑动加载
                        rankDataObj.isScrollLoading = false;
                        /*data为空且pagenum是0说明第一次加载就是空，显示暂无数据图片*/
                        rankDataObj.shownodatabox = (rankDataObj.pagenum==0);
                    }
                    if(rankDataObj.pagenum>0){
                        if((d.data.length>0&&d.data.length<Number(rankDataObj.pagesize))||(d.data.length==0&&rankDataObj.pagenum>0)){
                            //如果当前获取到的数据小于分页条数，禁止滑动加载
                            rankDataObj.isScrollLoading = false;
                            Com.nativeToast('没有更多数据');
                        }
                    }


                    if(rankDataObj.clonefixedbar_top==0 ||caculateOffsetTop){
                        exports.getActiveHeight();
                    }
                }else if(d.result[0].code == '11' || d.result[0].code == '18' || d.result[0].code == '19'){
                    return false;
                }else{
                    //Com.showNativeAlert('',d.result[0].code+':'+d.result[0].msg,['确定'],'');
                    Com.nativeToast(d.result[0].code+':'+d.result[0].msg);
                }
            },
            "isTradeLogin":false,
            "error":function(){
                Com.ajaxLoaded();
                rankDataObj.isanumation = false;
                rankDataObj.isScrollLoading = true;
                //Com.showNativeAlert('','网络不给力|getrtranklist',['确定'],'')
            }
        });
    },
    getActiveHeight:function(){
        //延迟50ms获取一下高度
        if(rankDataObj.timeOutGetHeight) clearTimeout(rankDataObj.timeOutGetHeight);
        rankDataObj.timeOutGetHeight = setTimeout(function(){
            var clonefixedbar = $('#gz_top_fixed');
            rankDataObj.clonefixedbar_top = (Math.round(Number(clonefixedbar.height()))).toFixed(2);//切换顶部菜单时由于解释文字长度不一致会导致class=='irnkbg'的高度不一致，因此，切换顶部菜单时需要更新一下这个值，调试的时候要处理
        },10)
    },
    splitStr : function(){
        var clientType =Com.clientType();
        var splitStr='<br/>';
        if(clientType=='ios'){
            splitStr='\n';
        }
        rankDataObj.splitStr = splitStr;
    },
    oftypechn:function(num){
        var typeStr = '';
        if(num == '1'){
            typeStr = '股票型';
        }
        else if(num == '2'){
            typeStr = '混合型';
        }
        else if(num == '3'){
            typeStr = '债券型';
        }
        else if(num == '4'){
            typeStr = '货币型';
        }

        else if(num == '5'){
            typeStr = '指数型';
        }
        else if(num == '6'){
            typeStr = 'QDII型';
        }else if(num=="7"){
            typeStr = '其他';
        }else if(num=="8"){
            typeStr = '指数型';
        }
        else{
            typeStr = "未知";
        }
        return typeStr;
    }




};

exports.init();

//在基金排行、定投排行页面上native调此方法回到首页(兼容老金太阳)
function fundRankGoBack(){
    if(typeof nativeContext !== 'undefined') {
        nativeContext.goBack(1, '');
    }
}